#define	DEFAULT_X64_LCD_CONTRAST		6
#define	DEFAULT_DENSITRON_LCD_CONTRAST	6

// --------------------- External variables from SYS90 ---------------------

#define	debug_rfid_barcode					0
#define	multi_alpha_modes					1

#IF radio_type gprs ;
#define	gsm_power_button_pressed	write_cpu_register(CPU_LHH_VALUE,59136+8);
#define	gsm_reset				write_cpu_register(CPU_LHH_VALUE,59136+16);
#define	gsm_standby				write_cpu_register(CPU_LHH_VALUE,59136+24);
int gsm_error;
#ENDIF ;

int show_hours_var = compile_show_hours;

extern public struct FORM_FIELDS *form_func_browse_form;
extern public int key_func_browse_form;
extern public int voltage_func_power_off_countdown;
extern public int status_func_update_radio_flags;
extern public char get_serial_number[1];
extern public char set_serial_number[1];
extern public int togu_func_update_radio_flags;
extern public char edit_serial_number[1];
extern public int form_display_func_setformptr;
extern public int value_func_pic_version;
extern public int voltage_func_battery_voltage;
extern public int next_update_func_power_off_countdown;
extern public int processor_ips;
extern public int charging_func_update_battery;
extern public int battery_voltage_peak_func_update_battery;
extern public int battery_voltage_dip_func_update_battery;

// --------------------- Variables and Defines -----------------------------

//int CPU_EEPROM_LOCK=217;

#define FIVESECONDS				1310720
#define FOURSECONDS				1048576
#define TWOSECONDS				524288
#define ONESECOND				262144
#define ONEMILISECOND				262
#define HALFASECOND				131072
#define ONEFOURTHOFASECOND		65536
#define ONETENTHOFASECOND			104858
#define ONEFIFTHOFASECOND			209715
#define ONETHIRDOFASECOND			349525

#IF system_version 700 701 702 703 704 705 706 707 708 709 710 ;
#define	key_repeat_timer_down_value 		120
#ENDIF ;


// -------------------------------------------------------------------------

#IF compile_alarm 1 ;
int check_alarm2;
set_alarm(int vector, int time, int repeat)
{	
}
#ENDIF ;

// -------------------------------------------------------------------------

// COM Mask:
//			COM2  XXXX  XXXX  XXXX  RFID  XXXX  XXXX  XXXX

public set_baud_rate2(int baud)
{
	#IFLESS system_version 300 ;
		write_cpu_register16(CPU_COM2BAUD,( ( (clock_frequency/4) / baud - 16 ) / 7 ) - 1 );
		write_cpu_register32(CPU_COM2BAUD+6,baud_rate(baud)*2);
	#ENDIF ;
	
	#IFGREATEROREQUAL system_version 300 ;
	#IFLESS system_version 400 ;
		write_cpu_register16(CPU_COM2BAUD,( ( (clock_frequency/4) / baud - 16 ) / 7 ) - 1 );
		write_cpu_register16(CPU_COM2BAUD_WSB,65535+19+29-processor_ips*15/10/baud);
		write_cpu_register16(CPU_COM2BAUD_WBITS,65535+19-processor_ips/baud);
	#ENDIF ;
	#ENDIF ;
	
	#IFGREATEROREQUAL system_version 400 ;

		if(value_func_pic_version<750)
		{
// antigo, pic 17c44
			write_cpu_register16(CPU_COM2BAUD, processor_ips/baud );
			write_cpu_register16(CPU_COM2BAUD_WSB,65535+19+29-processor_ips*15/10/baud);
			write_cpu_register16(CPU_COM2BAUD_WBITS,65535+19-processor_ips/baud);
		}
		else
		{
			if(value_func_pic_version>=796)
			{
// novo, ultima versao
				write_cpu_register16(CPU_COM2BAUD, processor_ips/baud-15 );						// verificado no osciloscopio
				if(baud==115200)
				{
					write_cpu_register16(CPU_COM2BAUD_WBITS,65535);
				}
				else
				{
					write_cpu_register16(CPU_COM2BAUD_WSB,(65536+55)-(processor_ips*15/10/baud) );	// verificado no osciloscopio
					write_cpu_register16(CPU_COM2BAUD_WBITS,(65536+25)-(processor_ips/baud));		// verificado no osciloscopio
				}
			}
			else
			{
// novo, penultima versao (7.90)
				write_cpu_register16(CPU_COM2BAUD, processor_ips/baud-15 );
				write_cpu_register16(CPU_COM2BAUD_WSB,(65536+56)-(processor_ips*15/10/baud) );
				write_cpu_register16(CPU_COM2BAUD_WBITS,(65536+30)-(processor_ips/baud));
			}
		}
	#ENDIF ;
}

#IFLESS system_version 300 ;
oldfunctionwaev(int event,int delay)
{
	wait_event(event+256*delay);
}
#define wait_event oldfunctionwaev
#ENDIF ;

#IF system_type rio vertical horizontal ;
#define 	CONFIG_VERSION					"T022"
#ENDIF ;

#IF software_type RADIOBASE ;
#define 	CONFIG_VERSION					"B022"
#ENDIF ;

#IF software_type BATCH ;
#define 	CONFIG_VERSION					"I002"
#ENDIF ;

#IF software_type BATCH ;
#IF radio_type gprs  ;
#define 	CONFIG_VERSION					"G003"
#ENDIF ;
#ENDIF ;


#IF software_type TELNET ;
#define 	CONFIG_VERSION					"L002"
set_vt100_attribute(int a)
{
	char attribute[8]={0,0,0,0,128,255,0,255};
	write_cpu_register(162,attribute[a]);
}

public set_vt100_display(public char *display_address)
{
	int n;

	n=ptr_func_set_display_buffer&255;
	n=256-n;
	n=255&n;

	set_display_buffer( ptr_func_set_display_buffer+n, size_func_set_display_buffer-n, 256 );
	set_display(display_address);
	write_cpu_register(CPU_SCREENLINE1+3,read_cpu_register(CPU_SCREENLINE1+3)|32);
	write_cpu_register(CPU_SCREENLINE2+3,read_cpu_register(CPU_SCREENLINE2+3)|32);
	write_cpu_register(CPU_SCREENLINE3+3,read_cpu_register(CPU_SCREENLINE3+3)|32);
	write_cpu_register(CPU_SCREENLINE4+3,read_cpu_register(CPU_SCREENLINE4+3)|32);
	write_cpu_register(CPU_SCREENLINE5+3,read_cpu_register(CPU_SCREENLINE5+3)|32);
	write_cpu_register(CPU_SCREENLINE6+3,read_cpu_register(CPU_SCREENLINE6+3)|32);
	write_cpu_register(CPU_SCREENLINE7+3,read_cpu_register(CPU_SCREENLINE7+3)|32);
	write_cpu_register(CPU_SCREENLINE8+3,read_cpu_register(CPU_SCREENLINE8+3)|32);
}
#ENDIF ;


#define	critical_operation_voltage_limit_start		4750
#define	critical_operation_voltage_limit_limit		4550

#IF laser_type none ;
#IF gps_type none ;
#IF tag_type none ;

  #define	critical_operation_voltage_limit_start		4400
  #define	critical_operation_voltage_limit_limit		4400

#ENDIF;
#ENDIF;
#ENDIF;




// --------------------- Variables -----------------------------------------

#IFGREATEROREQUAL system_version 700 ;
#define ponto_char 144
#ELSE ;
#define ponto_char '.'
#ENDIF ;

#IF language portugues ;
char auxstring1[36]={252,"Pressione",254,129,130,253,32,254,ponto_char,32,253,251,32,32,32,32,32,32,32,32,32,32,32};
char auxstring2[27]={"Bateria Fraca             "};
#ENDIF ;

#IF language english ;
char auxstring1[36]={252,"Press",254,129,130,253,32,254,ponto_char,32,253,251,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32};
char auxstring2[27]={"Low Battery               "};
#ENDIF ;

#IF language espanol ;
char auxstring1[36]={252,"Pulse",254,129,130,253,32,254,ponto_char,32,253,251,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32};
char auxstring2[27]={"Bateria Descargada        "};
#ENDIF ;

#IFGREATEROREQUAL system_version 600 ;
char auxstring0[28]={142,143,"                        "};
#ELSE ;
char auxstring0[28]={"Teclado Bloqueado         "};
#ENDIF ;
char auxstring3[35]={"       ",252,"www.x64.com",253,"            "};

#IF compile_debug_trace 1 ;
	int debug_trace_on;
	int debug_trace_value;
	int debug_correction_time;
#ENDIF ;

public struct FORM_FIELDS system_form[number_of_form_lines];

public char blank_screen_line[31]="                              ";

char space_in_text;

public char *function_before_power_off;
public char *function_before_power_up;

public int system_version_int = system_version;
public int system_type_number_int = system_type_number;

public int hardware2;
public int status_rfid;


//public int absolute_time_seconds;
public int absolute_time_seconds_start;
public int absolute_time_seconds_quartz;
public int absolute_time_seconds_adjust;

#IFNOT tag_type none ;
public int reading_rfid;
public	set_rfid_baud_rate(int baud)
{
	write_cpu_register(CPU_COMPORT_MASK,read_cpu_register(CPU_COMPORT_MASK)|8);
//	write_cpu_register(CPU_COMPORT_MASK,8);
	write_cpu_register16(CPU_RFIDBAUD, processor_ips/baud-15 );
	write_cpu_register16(CPU_RFIDBAUD_WSB,(65536+56)-(processor_ips*15/10/baud) );
	write_cpu_register16(CPU_RFIDBAUD_WBITS,(65536+23)-(processor_ips/baud));
}
#ENDIF ;


public int hardware_is_ementa;
public int hardware_is_pricechecker;
public int hardware_is_laser_intermec;
public char *display_ram;
public int display_width;
public int display_height;
public int lcd_width;
public int lcd_pixels_width;
public char *print_ram;
public int print_width;
public int print_height;
public int shift_key;
public int internal_shift_key;
public int release_key;
#IF calculator_floats 1 ;
public int decimal_points;
#ENDIF ;

public int alpha_mode;
public int multitap_alpha;
public int caps_lock;
public int inside_os_menu;
public int os_language;
public int screen_format;
public int lcd_light_power;
public int lcd_light_state;
public int enabled_function_keys;
public int function_keys_active;
public int title_lines;
public int debug_lines;
public int com_enabled_all_the_time;
public int drawing_form;
public int print_witdh;
public int last_gprs_error;
public int battery_management_version_var=battery_management_version;

public int offline_function_to_test_if_it_is_empty;

int key_repeat_timer;
int continuouskeypress;
int key_repeat_times;

char *function_keys_screenline_base;
char *function_keys_screenline_template;

public int formptr;
public int read_start_field;
public int read_start_field_title;
public int read_background_function;

public int power_is_off;

public int model_number;
public int product_code;

int power_off_countdown_start;
int light_off_countdown_start;
int menu_exit_countdown_start;
int laser_on_time;
int light_off_countdown_seconds;
int power_off_countdown_seconds;
int battery_charge;
int last_battery_charge;
int battery_voltage_index;
int unlimited_operation_voltage_limit;
int critical_operation_voltage_limit;
int battery_voltage_adjustment;
int base_send_to_serial_or_radio;
int startup_test;

#IF tag_type TagIt  ;
	int tagMifare;
#ENDIF ;

#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 708 ;
int startup_test2;
#ENDIF ;
#ENDIF ;

#IF system_type vertical ;
int upside_down;
public int browse_form_lines;
public char function_keys_screenline1[32];
public char function_keys_screenline2[32];
int SystemLinkScreenNumber;
int system_text_value;
int system_exit_read_type;
#ENDIF ;

#IF system_type horizontal rio ;
int upside_down;
public int browse_form_lines=4;
public char function_keys_screenline1[32];
public char function_keys_screenline2[32];
int SystemLinkScreenNumber;
int system_text_value;
int system_exit_read_type;
// int esc_screen_number;
#ENDIF ;

int form_title_cursor;
	
public int getch_waits_for_serie;
public int getch_waits_for_radio;

int time_to_reset;
int NumberOfBases;
int AutoFindBase;

#define temp_string_size	2000
public char temp_string[temp_string_size];		// 1000

				// Comunication variables
int MessageIdCount;
int RetransmitType;
int BlockIncrNumber;
char ExpectedBlockId[9];

public char remote_id[9];
public char work_base_id[9];
char os_menu_password[5];

public char var_changed_by_dll[9];
int confirmations_timeout;

				// End Comunication variables

#IF software_type BATCH ;
#IF radio_type gprs ;
	char dial_ip[50];
#ENDIF ;
#IF compile_alarm 1 ;
	char connectat[5];
#ENDIF ;
#ENDIF ;


// --------------------- LCD settings --------------------------------------

public cursor_height(int n)
{
	write_cpu_register(CPU_REVERSE_T,n);
}

public cursor_width(int n)
{
	write_cpu_register(CPU_REVERSE_N,n);
}

// --------------------- LCD (display) -------------------------------------

enable_update_screen()
{
	write_cpu_register(CPU_BASIC_FLAGS,48896);
}

disable_update_screen()
{
	write_cpu_register(CPU_BASIC_FLAGS,65344);
}

public set_update_screen(int on)
{
	if(on)
	{
		write_cpu_register(CPU_BASIC_FLAGS,48896);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,65344);
	}
}

really_update_screen()
{
	push_variable(read_cpu_register(CPU_BASIC_FLAGS));
	write_cpu_register(CPU_BASIC_FLAGS,48896);
	update_screen();
	write_cpu_register(CPU_BASIC_FLAGS,pop_variable());
}

really_update_screen_and_disable()
{
	write_cpu_register(CPU_BASIC_FLAGS,48896);
	update_screen();
	write_cpu_register(CPU_BASIC_FLAGS,65344);
}

really_update_screen_and_enable()
{
	write_cpu_register(CPU_BASIC_FLAGS,48896);
	update_screen();
}

#IF system_type vertical ;

char *status_line_txt;

set_display_buffer(int ptr,int size,int width)
{
	print_ram=ptr;
	print_width=width;
	print_height=size/width;
	display_ram=ptr;
	display_width=width;
	display_height=size/width;
}

public set_display(public char *display_address)
{
	int n;
	char *a;
	int bit;
	if(value_func_pic_version>=715)
	{
		lcd_pixels_width=128;
		if(!screen_format)
		{
			lcd_width=26;
		}
		else
		{
			lcd_width=22;
		}
	}
	else
	{
		lcd_pixels_width=100;
		if(!screen_format)
		{
			lcd_width=20;
		}
		else
		{
			lcd_width=17;
		}
	}
	a=display_address;
	bit=1;
	browse_form_lines=0;
	for(n=title_lines+debug_lines;n<8;n++)
	{
		if(n>=6)
		{
			if( enabled_function_keys || status_line_txt )
			{
				if(n==6)
				{
#IFGREATEROREQUAL system_version 700 ;
					if(screen_format&bit)
					{
						write_cpu_register32(CPU_SCREENLINE7,blank_screen_line);
						break;
					}
#ENDIF ;
				}
				else
				{
					break;
				}
			}
		}
#IFGREATEROREQUAL system_version 700 ;
		if( screen_format&bit )
		{
			write_cpu_register32(CPU_SCREENLINE1+4*n,display_ram+a+64*256*256*256);
			if(n<7)
			{
				browse_form_lines++;
				write_cpu_register32(CPU_SCREENLINE2+4*n,display_ram+a+(128+64)*256*256*256);
				n++;
			}
		}
		else
		{
#ENDIF ;
			write_cpu_register32(CPU_SCREENLINE1+4*n,display_ram+a);
			browse_form_lines++;
#IFGREATEROREQUAL system_version 700 ;
		}
#ENDIF ;
		a+=display_width;
		bit=bit*2;
	}
	restore_function_keys();
	update_screen();
}
#IF compile_radio_message 1 ;
public int show_status_line(char *txt)
{
	if(status_line_txt=txt)
	{
		write_cpu_register32(CPU_SCREENLINE8,txt);
	}
	else
	{
		set_display(display_address_func_set_display);
	}
	really_update_screen();
}
#ENDIF ;
#ELSE ;
public set_display(public char *display_address)
{
	int n;
	browse_form_lines=0;

	if(value_func_pic_version>=715)
	{
		lcd_pixels_width=babaub;
		lcd_width=26;
	}
	else
	{
		lcd_pixels_width=100;
		lcd_width=20;
	}
	
	for(n=title_lines;n<4;n++)
	{
		write_cpu_register32(CPU_SCREENLINE1+4*n,display_ram+display_address+n*display_width);
		browse_form_lines++;
	}
	update_screen();
}
#ENDIF ;

restore_function_keys()
{
	if(!power_is_off)
	{
		if( internal_shift_key && enabled_function_keys>4 )
		{
			write_cpu_register32(CPU_SCREENLINE8,function_keys_screenline2);
			update_screen();
		}
		else
		{
			if( enabled_function_keys )
			{
				write_cpu_register32(CPU_SCREENLINE8,function_keys_screenline1);
				update_screen();
			}
		}
	}
	
}

public int set_function_keys(char *t1,int fsize)
{
	char *src;
	int src_size;
	char *dest;
	int last_enabled_function_keys;
	int last_t1;
	int n,nn;
	char *dest_template;
	
	function_keys_active=1;

	if(t1==last_t1)
	{
		restore_function_keys();
		return;
	}
	last_t1=t1;

	if(!function_keys_screenline_base)
	{
		if(value_func_pic_version>=715)
		{
			function_keys_screenline_base=function_keys_screenline_base26;
			function_keys_screenline_template=function_keys_screenline_template26;
		}
		else
		{
			function_keys_screenline_base=function_keys_screenline_base20;
			function_keys_screenline_template=function_keys_screenline_template20;
		}
	}

	last_enabled_function_keys=enabled_function_keys;

	memcpy(function_keys_screenline1,function_keys_screenline_base,32);
	memcpy(function_keys_screenline2,function_keys_screenline_base,32);
	
	src=t1;
	src_size=strlen(src);
	enabled_function_keys=src_size/fsize;

	nn=fsize-1;
	if(nn<1)
	{
		nn=1;
	}

	n=enabled_function_keys;
	dest=function_keys_screenline1;
	dest_template=function_keys_screenline_template;
	while(n)
	{
		dest+=(*dest_template);
		dest_template++;
		memcpy(dest,src,nn);
		src+=fsize;
		n--;
	}

	sensech2();

	if( enabled_function_keys && !last_enabled_function_keys )
	{
		if( read_cpu_register32(CPU_DX)>=(display_ram+display_address_func_set_display+display_width*(browse_form_lines-1)))
		{
			set_display(display_address_func_set_display+display_width);
			return;
		}
	}
	set_display(display_address_func_set_display);
	update_screen();
}

// --------------------- Battery Bar ---------------------------------------

#IFGREATEROREQUAL system_version 600 ;
#IF compile_os_menu 1;
public battery_bar(int battery_bar_status)
{
	int enabled;
	push_variable(n_func_cursor_height);
	cursor_height(0);

	if(value_func_pic_version>=715)
	{
		write_cpu_register(CPU_LCD_WIDTH,128);
	}
	else
	{
		write_cpu_register(CPU_LCD_WIDTH,100);
	}

	really_update_screen();
	cursor_height(pop_variable());
	if(!battery_bar_status)
	{
		battery_bar_status=enabled;
	}
	if(battery_bar_status==-1)
	{
		enabled=-1;
	}
	if(battery_bar_status==1)
	{
		enabled=1;
	}

	if(battery_bar_status>0)
	{
		show_battery(battery_charge/64);
		if(value_func_pic_version>=715)
		{
			write_cpu_register(CPU_LCD_WIDTH,114);
		}
		else
		{
			write_cpu_register(CPU_LCD_WIDTH,86);
		}
	}

	if(battery_bar_status==-100)
	{
		show_battery(0);
		if(value_func_pic_version>=715)
		{
			write_cpu_register(CPU_LCD_WIDTH,114);
		}
		else
		{
			write_cpu_register(CPU_LCD_WIDTH,86);
		}
	}

}
#ENDIF ;
#ENDIF ;

#IFLESS system_version 600 ;
#IF compile_os_menu 1;
#define compile_sprites 1
public battery_bar(int battery_bar_status)
{
	char bar[11]={4,2,0,255,255,255,255,63,63,63,63};
	char bat[13]={5,2,0,248,12,4,12,248,63,32,32,32,63};
	int enabled;
	int n;
	push_variable(n_func_cursor_height);
	cursor_height(0);
	for(n=0;n<10;n++)
	{
		if(print_ram[19+print_width*n]==250)
		{
			print_ram[19+print_width*n]=' ';
		}

		if(print_ram[20+print_width*n]==250)
		{
			print_ram[20+print_width*n]=' ';
		}
	}
	really_update_screen();
	cursor_height(pop_variable());
	if(!battery_bar_status)
	{
		battery_bar_status=enabled;
	}
	if(battery_bar_status==-1)
	{
		enabled=-1;
	}
	if(battery_bar_status==1)
	{
		enabled=1;
	}
	if(battery_bar_status>0)
	{
		print_sprite_at_character_line(bat,95,6);
		n=battery_charge/64;
		while(n)
		{
			print_sprite_at_character_line(bar,99-n,6-2*n);
			n--;
		}
		for(n=0;n<10;n++)
		{
			print_ram[19+print_width*n]=250;
			print_ram[20+print_width*n]=250;
		}
	}
	really_update_screen();
}
#ENDIF ;
#ENDIF ;

// --------------------- LCD (print) ---------------------------------------

public cursor(int x)
{
	write_cpu_register32(CPU_DX,print_ram+x);
}

public cursor_line(int line)
{
	cursor(print_width*line);
}

public tab(int n)
{
	cursor( print_width * ( get_cursor() / print_width ) + n );
}

public new_line()
{
	cursor_line(get_cursor()/print_width+1);
}

public get_cursor()
{
	return(read_cpu_register32(CPU_DX)-print_ram);
}

#IF compile_scroll 1 ;
public scroll(char *t,int size)
{
	if(strlen(t)>size)
	{
		form_title_cursor=(read_cpu_register32(CPU_DX)-print_ram);
		system_form[formptr].cursor		=form_title_cursor;
		print_short_string(t,size);
		system_form[formptr].cursorlen	=size;
		system_form[formptr].scroll_string	=t;
	}
	else
	{
		say(t);
	}
}

public scroll2(char *t)
{
	form_title_cursor=(read_cpu_register32(CPU_DX)-print_ram);
	system_form[formptr].cursor		=form_title_cursor;
	print_string(t+strlen(t)+1);
	system_form[formptr].cursorlen	=strlen(t+strlen(t)+1);
	system_form[formptr].scroll_string	=0-t;
}
#ENDIF ;

public cls()
{
#IF software_type TELNET ;
	if(read_cpu_register(CPU_SCREENLINE1+3)&32)
	{
		memset(print_ram,0,print_width*print_height);
		set_vt100_attribute(0);
	}
	else
	{
		memset(print_ram,' ',print_width*print_height);
	}
#ELSE ;
		memset(print_ram,' ',print_width*print_height);
#ENDIF ;
	cursor(-1);
	update_screen();
	cursor(0);
	formptr=0;
	read_start_field=0;
	read_start_field_title=0;
	read_background_function=0;
}

// -------------------------------------------------------------------------

public char os_baud_rates[11][7]={
			"300   ",
			"1200  ",
			"2400  ",
			"4800  ",
			"9600  ",
			"19200 ",
			"36480 ",
			"38400 ",
			"40320 ",
			"57600 ",
			"115200"
		};

public choose_baud_rate(int index)
{
	set_baud_rate( atoi(os_baud_rates[index]) );
}

public	set_com2_baud_rate(int baud)
{
	write_cpu_register(CPU_COMPORT_MASK,read_cpu_register(CPU_COMPORT_MASK)|128);
	set_baud_rate(baud);
}

public set_baud_rate(int baud)
{
	set_baud_rate2(baud);

	for(index_func_choose_baud_rate=8;index_func_choose_baud_rate>=0;index_func_choose_baud_rate--)
	{
		if(atoi(os_baud_rates[index_func_choose_baud_rate])==baud)
		{
			break;
		}
	}
}

#IF compile_com_message 1 ;

#ENDIF ;

empty_com2_buffer()
{
int c;
	write_cpu_register32(CPU_COM_TIMEOUT,0);
	do
	{		
		c=read_com2_byte();		
	}while(c>0);
}


// ------------------------------------ External Hardware ------------------------------------------------------

// ------------------------------------ BIO-FSM -------------------------------------------------------------------

#IF bio_type FSM ;

public empty_bio_buffer()
{
//	int ct;
	do
	{
//		ct++;
	}
	while(laser_read_byte() != -1 );			
}

public bio_terminate()
{
	disable_com_port_enable_timer();
	choose_baud_rate(index_func_choose_baud_rate);	
	write_cpu_register(CPU_COMPORT_MASK,128);
	write_cpu_register(CPU_PORTB_VALUE,256*255+16);
	write_cpu_register(CPU_DDRB_VALUE,256*255+16);
	
}

public bio_initialize()
{	
	clrwdt();
	enable_com_port_disable_timer();
	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	write_cpu_register(CPU_COMPORT_MASK,32);
	write_cpu_register(CPU_DDRB_VALUE,256*255+32);
	write_cpu_register(CPU_DDRB,255*256+32);
	set_baud_rate2(9600);

	laser_write_byte(0);
	delay(25000);
}	

public wait_bio_header()
{
	int ct;
	int byte;

	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	
	ct=0;
	do
	{
		ct++;
		byte=laser_read_byte();
	}
	while(byte!= 27 && ct<100);		

	do
	{
		ct++;
		byte=laser_read_byte() ;
	}
	while(byte!= 94 && ct<100);		
	
	if(ct>=100)
	{
/*
		cls();
		print_string("ERROR Bio:");
		print_number(byte);
		getch();
*/
		return(-1);
	}
	return(laser_read_byte());
}

public bio_reset()
{	
	empty_bio_buffer();

	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(160);
	laser_write_byte(0);
	laser_write_byte(0);
	if(wait_bio_header()==161)
	{
		laser_read_byte();
		laser_read_byte();
		return(0);
	}	
	else
	{
		return(-1);
	}
}	

public bio_register_user_id(int id )
{	
	int byte;

	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(32);
	laser_write_byte(0);
	laser_write_byte(id);

	do
	{
		byte=wait_bio_header();
		if(byte==33)
		{
			laser_read_byte();
			laser_read_byte();
			return(0);
		}	

		if(byte==34)
		{
			laser_read_byte();
			byte=laser_read_byte();
			return(0-byte);
		}
	}
	while(byte!=-1);
	return(-1);
}	

public bio_check_user_id(int id)
{	
	int byte;
	
	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(64);
	laser_write_byte(0);
	laser_write_byte(id);

	do
	{			
		byte=wait_bio_header();
		if(byte==65)
		{
			laser_read_byte();
			laser_read_byte();
			return(0);
		}	
	
		if(byte==66)
		{
			laser_read_byte();
			byte=laser_read_byte();
			return(0-byte);
		}	
	
	}
	while(byte!=-1);
	return(-1);
}

public bio_read_user_id()
{	
	int byte;
	
	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(112);
	laser_write_byte(0);
	laser_write_byte(0);

	do
	{			
		byte=wait_bio_header();
		if(byte==113)
		{
			laser_read_byte();
			return(laser_read_byte());
		}	
	
		if(byte==114)
		{
			laser_read_byte();
			byte=laser_read_byte();
			return(0-byte);
		}	
	
	}
	while(byte!=-1);
	return(-1);
}

public bio_delete_all()
{
	int byte;
//	empty_bio_buffer();

	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(163);
	laser_write_byte(0);
	laser_write_byte(0);
	
	do
	{			
		byte=wait_bio_header();	
		if(byte==164)
		{
			laser_read_byte();
			laser_read_byte();
			return(0);
		}		
	}
	while(byte!=-1);
	return(-1);
}

public bio_delete(int id)
{
	int byte;

	laser_write_byte(27);
	laser_write_byte(94);
	laser_write_byte(48);
	laser_write_byte(0);
	laser_write_byte(id);

	do
	{
		byte=wait_bio_header();
		if(byte==49)
		{
			laser_read_byte();
			laser_read_byte();
			return(0);
		}	

		if(byte==50)
		{
			laser_read_byte();
			byte=laser_read_byte();
			return(0-byte);
		}
	}
	while(byte!=-1);
	return(-1);
}

#ENDIF ;

// --------------------- Rotinas de SLEEP ----------------------------------

#IFLESS system_version 700 ;
public set_ir_power(int n)
{
	write_16c71_byte(13-n);
}
#ENDIF ;


public power_off_countdown_restart()
{
	menu_exit_countdown_start  = read_cpu_register32_verified(CPU_SECONDS_COUNTER);
	power_off_countdown_restart2();
}

public power_off_countdown_restart2()
{
	light_off_countdown_start = read_cpu_register32_verified(CPU_SECONDS_COUNTER);
	power_off_countdown_start  = read_cpu_register32_verified(CPU_SECONDS_COUNTER);
	set_lcd_light_power(lcd_light_power);
}

// --------------------- Keyboard ------------------------------------------


#include "sys61.c"

def_getch2_function()
{
	int n;
	int passed_time;
			while( read_cpu_register32_verified(CPU_SECONDS_COUNTER) < menu_exit_countdown_start + getch_waits_for_serie )
			{
#IF system_version 700 701 702 703 704 705 706 707 708 709 710 ;
				if(value_func_pic_version<=710)
				{
					enable_com_port_disable_timer();
					clrwdt();
					n=wait_event( 1+8+4+32+ 262144 + 524288, 160000);
					disable_com_port_enable_timer();
				}
				else
				{
					n=wait_event( 1+8+4+2097152 , getch_waits_for_serie );
				}
#ELSE ;			
				n=wait_event( 1+8+4+2097152 , getch_waits_for_serie );
#ENDIF ;
				if(n&8)
				{
					beep(10,10);
					return(SERIE_KEY);
				}
				if(n&1)
				{
					break;
				}
			}

			if(sensech())
			{
				return(0);
			}

			while( read_cpu_register32_verified(CPU_SECONDS_COUNTER) < menu_exit_countdown_start + getch_waits_for_radio )
			{
				push_variable(get_seconds());
				radio_channel_receive
#IF system_version 700 701 702 703 704 705 706 707 708 709 710 ;

				if(value_func_pic_version<=710)
				{
					n=wait_event(1 + 4 + 32 + 64 + 262144+524288,160000);
				}
				else
				{
					if(getch_waits_for_radio>10)
					{
						n=wait_event(1 + 4 + 64 + 262144,10);
					}
					else
					{
						n=wait_event(1 + 4 + 64 + 262144,getch_waits_for_radio-1);
					}
				}
#ELSE ;	
				if(getch_waits_for_radio>10)
				{
					n=wait_event(1 + 4 + 64 + 262144,10);
				}
				else
				{
					n=wait_event(1 + 4 + 64 + 262144,getch_waits_for_radio-1);
				}
#ENDIF ;

				radio_channel_off
				power_off_countdown();

				passed_time=pop_variable();
				passed_time=get_seconds()-passed_time;
				if(n&1)
				{
					break;
				}
				if( n & 64 )
				{			
					return(RADIO_KEY);
				}
			}
			
			return(0);
}

public getch2()
{
	public int key;
	int n;
	int function;

	while(!(key=sensech()))
	{
		if(internal_shift_key)
		{
			continue;
		}
		if(!key_repeat_timer)
		{
			if(function)		
			{
				n=function();
				if(n)
				{
					return(n);
				}
			}
#IF compile_alarm 1 ;
			if(check_alarm2!=0)
			{
				check_alarm2();
			}
#ENDIF ;
			if(sensech())
			{
				continue;
			}
		}
		if(input_timeout)
		{
			if( read_cpu_register32_verified(CPU_SECONDS_COUNTER) > menu_exit_countdown_start + input_timeout )
			{
				return(27);
			}
		}
		if( ( read_cpu_register(CPU_BASIC_FLAGS) & 2 ) == 0 )
		{
			if(!key_repeat_timer)
			{

				key=wait_event(5,5);

				if(!(key&1))
				{
					power_off_countdown();
				}

			}
		}
	}
	keyboard_read_from_buffer(1);
	return( key );
}

public set_key_repeat_timer()
{
	if( pic_version()<750 )							// emulator doesn't have battery control
	{
		if( pic_version()>=720 )
		{		
			if(key_repeat_times)
			{
				key_repeat_timer=key_repeat_timer_down2_value*10;
			}
			else
			{
				key_repeat_timer=key_repeat_timer_down_value*10;
			}
			return;
		}
	}
	if(key_repeat_times)
	{
		key_repeat_timer=key_repeat_timer_down2_value;
	}
	else
	{
		key_repeat_timer=key_repeat_timer_down_value;
	}
}

// --------------------- Keyboard - Scancode Translation -------------------

public update_function_key_caps()
{
	char *dest;
	char *dest_template;
	int n;

	if( caps_lock )
	{
		n=enabled_function_keys;
		dest=function_keys_screenline1;
		dest_template=function_keys_screenline_template;
		while(n)
		{
			dest+=(*dest_template);
			dest_template++;
			*dest=capitalize(*dest);
			n--;
		}
	}
	else
	{
		n=enabled_function_keys;
		dest=function_keys_screenline1;
		dest_template=function_keys_screenline_template;
		while(n)
		{
			dest+=(*dest_template);
			dest_template++;
			*dest=decapitalize(*dest);
			n--;
		}
	}
/*
	push_variable(internal_shift_key);
	internal_shift_key=caps_lock;
	restore_function_keys();
	internal_shift_key=pop_variable();
*/
}

disable_shift_key()
{
	if(internal_shift_key)
	{
		internal_shift_key=0;
		restore_function_keys();
		if(!power_is_off)
		{
			if(!drawing_form)
			{
				really_update_screen();
			}
		}
	}
}

public translate_scancode(int c)
{
	int internal;
	int function_key;
	char *t;
	int key7;
/*	
	if(read_cpu_register(1)&2)
	{
		if(value_func_pic_version>=794)
		{
			return(c-255);
		}
	}
*/
	t=&keytable;
	if( c && c<=256 )
	{
		internal=0;
		return(c);
	}
	else
	{
		if(c)
		{
			c=c-256;
		}
		internal=1;
		if(c>=64)
		{
			if(internal_shift_key!=1)
			{
				internal_shift_key=1;
				restore_function_keys();
				if(!power_is_off)
				{
					really_update_screen();
				}
			}
		}
		else
		{
			disable_shift_key();
		}
		c=t[c+128*upside_down];
		if( c>=240 && c<=247 )
		{
			function_key=c-240;
											// F0 F1 F2 F3
			if( enabled_function_keys && function_keys_active )
			{
				c=0;			
				if(function_key<enabled_function_keys)
				{
					c=t1_func_set_function_keys[fsize_func_set_function_keys-1+fsize_func_set_function_keys*function_key];
					function_key++;
				}
				else
				{
					if( function_key>=4 && (function_key-4)<enabled_function_keys )
					{
						c=t1_func_set_function_keys[fsize_func_set_function_keys-1+fsize_func_set_function_keys*(function_key-4)];
						function_key++;
					}
					else
					{
						function_key=0;
					}
				}
/*										// F1 F2 F3 F4
				if( c==' ' )					// ' ' in any key except F4 or F8 means no key
				{
					if( function_key!=4 )
					{
						function_key=0;
						c=0;
					}
				}
*/
			}
			else
			{
				function_key=0;
			}
		}
		else
		{
			if(c)
			{
				function_key=0;
			}
		}
		if( caps_lock )
		{
			if( c >= 'a' && c <= 'z' )
			{
				c = c & 223;
			}
			else
			{
				if( c >= 'A' && c <= 'Z' )
				{
					c=c|32;
				}
			}
		}
		if(c==131)											// Caps Lock
		{
			if(read_cpu_register(CPU_REVERSE_N)==1)
			{
				if( caps_lock )
				{
					caps_lock=0;
				}
				else
				{
					caps_lock=1;
				}
				update_function_key_caps();
				set_text_cursor_height();
				update_screen();
				keyboard_beep();
				set_key_repeat_timer();
			}
			return(0);
		}
		if( c=='.' && internal_shift_key )							// Power Off
		{
			if( inside_os_menu<2 )
			{
				if(!key_repeat_times)
				{
					power_off();
				}
				return(0);
			}
		}
		if( ( c==255 || c==254 ) && !key_repeat_timer )				// OS menu
		{
			if( !inside_os_menu )
			{
	//			battery_voltage();
	//			update_battery_check_discharge();
				inside_os_menu++;
				enter_os_menu_beep
#IF compile_os_menu 1 ;			
				os_menu(255-c);
#ENDIF ;
				exit_os_menu_beep
				inside_os_menu--;
			}
			return(0);
		}
	}
	key7=c;
/*
	if(!one_on_top)
	{
		switch(c)
		{
			case '1':
				return('7');
			case '2':
				return('8');
			case '3':
				return('9');
			case '7':
				return('1');
			case '8':
				return('2');
			case '9':
				return('3');
		}
	}
*/
	if( c==13 || c==UP || c==DOWN )
	{
		reset_multitap();
	}

	return(c);
}

reset_multitap()
{
#IFNOT software_type xrt100c ;
	if(alpha_mode&2)
	{
		multitap_alpha=0;
	}
	else
	{
		multitap_alpha=-1;
	}
	cursor_height(128);
#ENDIF ;
}

#IFNOT laser_type none ;
/*
laser_write_byte2(char ch)
{
int ct;
int ct2;
	laser_write_byte(ch);
	if(ct2>7)
	{
		return;
	}

	if(!ct)
	{
		cls();
		print_string("->");
	}
	print_number(ch);
	print_string(".");
	if(ct>6)
	{
		new_line();
		ct=0;
		ct2++;
	}
	ct++;
}
#define laser_write_byte laser_write_byte2
*/
#ENDIF ;

public getch()
{
	public int key,start;

#IF multi_alpha_modes 1 ;
	int last_key;
	int counter;
	int next_key;
	char signs[4]={42,43,45,47};
	char punctuation[4]={'.', ':', ',', ';'};
	int k,n;
	int samechar;
#ENDIF ;

#IF software_type XRML2 BATCH;
	int nnn;


#IF tag_type TagIt novatronica Calypso Rfid125 ;
	char input_buffer[256];
#ELSE ;
	char input_buffer[100];
#ENDIF ;

#IF tag_type TagIt novatronica Calypso Rfid125;

	if( reading_rfid && !sensech() )
	{
		if(value_func_pic_version>750)
		{
			write_cpu_register(3987,(255-128)*256);
		}
		empty_com2_buffer();
		memset(input_buffer,0,100);
		nnn=read_any(input_buffer);
		if(value_func_pic_version>750)
		{
			write_cpu_register(3987,255*256+128);
		}

#IF software_type  BATCH;
char global_input_buffer[256];
		if(nnn==2)
		{
			strcpy(global_input_buffer,input_buffer);
			keyboard_save_in_buffer('1',0);
		}
#ENDIF ;

#IF software_type XRML2 ;
char last_barcode[100];
	
		if(nnn==1)
		{
			strcpy(last_barcode,input_buffer);
			barcode_data_received(input_buffer);
		}
		if(nnn==2)
		{
			rfid_data_received(input_buffer);
			if(*last_barcode)
			{
				barcode_data_received(last_barcode);
			}
		}
#ENDIF ;
	}
#ENDIF ;
#ENDIF ;

#IF multi_alpha_modes 1 ;
	if(next_key)
	{
		key=next_key;
		next_key=0;
		return(key);
	}
#ENDIF ;

	if(continuouskeypress)
	{
		continuouskeypress=0;
		while(inkey())
		{
		}
		flush_keyboard_buffer();
	}

	power_off_countdown_restart();

	if(samechar)
	{
		cursor(get_cursor()-1);
		really_update_screen();
		cursor(get_cursor()+1);
		for(n=1;n<300;n++)
		{
			if(sensech())
			{
				n=0;
				break;
			}
		}
		if(n)
		{
			counter=0;
			samechar=0;
			really_update_screen();
		}
	}
	key=getch2();
	power_off_countdown_restart();

#IF multi_alpha_modes 1 ;
	if( multitap_alpha==1 )
	{
		if(key!=last_key)
		{
			counter=0;
			samechar=0;
			last_key=key;
		}

		if( (key>='0'&&key<='9') || (key=='.') )
		{
			if(key_repeat_times)
			{
				next_key=key;
				continuouskeypress=1;
				counter=0;
			}
			else
			{
				if(alpha_mode&1)
				{
					if(key=='0')
					{
						next_key=signs[counter%3];
					}
					else
					{
						next_key=('A'|(1-caps_lock)*32)+(key-'1')*3+(counter%3);
						if(next_key==91)
						{
							next_key=' ';
						}
					}
				}
				else
				{
					if(key=='.')
					{
						next_key=punctuation[counter%3];
					}
					else
					{
						if(key=='1')
						{
							next_key=signs[counter%3];
						}
						else
						{
							if(key=='0')
							{
								next_key=' ';
							}
							else
							{
								start='A'+(key-'2')*3;
								if(key=='7')
								{
									counter=counter%4;
								}
								else
								{
									if(key=='9')
									{
										start='W';
										counter=counter%4;
									}
									else
									{
										counter=counter%3;
										if(key=='8')
										{
											start='T';
										}
									}
								}
								next_key=(start+counter)|((1-(internal_shift_key|caps_lock))*32);
							}
						}
					}
				}
				counter++;
			}
			if(samechar)
			{
				if(continuouskeypress)
				{
					samechar=0;
				}
				return(8);
			}
			else
			{
				k=next_key;
				next_key=0;
				samechar=1;
				return(k);
			}
		}
	}
#ENDIF ;

	if(key==27)
	{
		if(internal_shift_key)
		{
			if(function_key_func_translate_scancode==0)
			{
				reset(0);
			}
		}
	}
	return(key);
}


public capitalize(int c)
{
	if( c >= 'a' && c <= 'z' )
	{
		return(c&223);
	}
	return(c);
}
public decapitalize(int c)
{
	if( c >= 'A' && c <= 'Z' )
	{
		return(c|32);
	}
	return(c);
}

public keyboard_beep()
{
	int fkey;
#IFNOT system_type ponto ;
	fkey=function_key_func_translate_scancode;
#ENDIF ;
	if(inside_os_menu<2)
	{
#IFNOT system_type ponto ;
			beep(2,40);
#ELSE ;
			beep(10,beep_period);
#ENDIF ;
	}
}

// --------------------- 16c71 - LCD ---------------------------------------

public set_lcd_light_power( int  nn )
{
	if( nn < 0 )
	{
		nn=0;
	}
	else
	{
		lcd_light_power=nn;
	}

	if( nn != lcd_light_state )
	{
		write_16c71_byte(11-nn);
		lcd_light_state=nn;
	}
}

#IF system_type vertical ;
public set_lcd_contrast(int n)
{
	int a;
	if(n<0)
	{
		n=0;
	}
	if(n>16)
	{
		n=16;
	}
	a=2*n;
	if(a>31)
	{
		a=31;
	}
	lcd_contrast=n+1;

	if(value_func_pic_version<714)
	{
		write_lcd_command(128|a);
		if(upside_down)
		{
			write_lcd_command(204);
			write_lcd_command(161);
		}
		else
		{
			write_lcd_command(196);
			write_lcd_command(160);
		}
		write_lcd_command(166);
		write_lcd_status(123456789);
	}
	else
	{
		write_lcd_command(129);
		write_lcd_command(a&63);
	}
}
#ENDIF ;

#IF system_type rio horizontal ;
public set_lcd_contrast(int n)
{
	if(n>16)
	{
		n=16;
	}
	write_16c71_byte(7);
	write_16c71_byte(17-n);
	lcd_contrast=n+1;
}
#ENDIF ;

#IF system_type ponto ;
public set_lcd_contrast(int n)
{
}
#ENDIF ;

// --------------------- EEPROM --------------------------------------------

public save_program(int *address)
{
	int n;
	int changed;
	int error_message;
	
	if(address==4096)
	{
		n=getch();
	}
	else
	{
		n='Y';
	}
	
	if( n=='Y' || n=='1' )
	{

		do
		{
			changed=0;

#IFNOT system_type ponto ;
			n=fopen("PROGRAM","wb");
#ELSE ;
			n=eeprom_start+100;
#ENDIF ;

			beep(50,100);

			changed+=memcpy_if_memcmp(pointers_to_programs,&n,4,error_message);

			changed+=memcpy_if_memcmp(n,address, 4 + (*(address+3)) - (*(address+6)),error_message);

			n='3';
			changed+=memcpy_if_memcmp(terminal_boot_status,&n,1,error_message);
		}
		while(changed);
	}
	beep(200,200);
}

// -------------------------------------------------------------------------

public rnd(int max)
{
	int seed;
	seed=(1103515245 * seed + 12345) % 268435456;
	return(seed % max);
}

// -------------------------------------------------------------------------

#IF compile_table_lookup 1 ;
#IFNOT system_type ponto ;

public table_lookup(int index,int *table,int max)
{
	int ptr;
	ptr=max-2;
	while( ptr>0 && index < table[ptr*2] )
	{
		ptr--;
	}
	return( table[ptr*2+1] + ( index - table[ptr*2] ) * ( table[(ptr+1)*2+1] - table[ptr*2+1] ) / ( table[(ptr+1)*2] - table[ptr*2] ) );
}

#ENDIF ;
#ENDIF ;

#IFNOT software_type RADIOBASE ;
public ctoi(char c)
{
	if(isdigit(c))
	{
		return(c-'0');
	}
	else
	{
		return(0);
	}
}
#ENDIF ;
// -------------------------------------------------------------------------


#IF system_type ponto ;
int AutoAnswerModem;
Auto_answer_modem(int n)
{
	if(AutoAnswerModem==1)
	{
		write_com2_block("AT      ",8);
		write_com2_byte(13);
		delay(250000);

		write_com2_block("ATS0=1",6);
		write_com2_byte(13);
		delay(100000);

		write_com2_block("AT",2);
		write_com2_block(dial_string,10);
		write_com2_byte(13);
		delay(100000);
		
	}
	else
	{
		write_com2_block("ATS0=0",6);
		write_com2_byte(13);
		delay(100000);
	}
}

#ENDIF ;

// -------------------------------------------------------------------------

public display_os_function_keys()
{
#IF system_type ponto ;
	char bitmap[5][8]=	{
							0,31,27,17,0,27,27,31,
							0,31,27,27,0,17,27,31,
							0,31,27,19,0,19,27,31,
							0,31,27,25,0,25,27,31,
							0,31,31,31,31,31,31,31
						};
	char tkline[20];

	write_cpu_register32(CPU_SCREENLINE4,tkline);
	update_screen();

	define_char(0,bitmap[0]);
	define_char(1,bitmap[1]);
	define_char(2,bitmap[2]);
	define_char(3,bitmap[3]);
	define_char(4,bitmap[4]);
	
	memset(tkline,4,20);
	tkline[2]=8;
	tkline[7]=1;
	tkline[12]=2;
	tkline[17]=3;

	update_screen();
#ENDIF ;
}
	
// -------------------------------------------------------------------------

#IFNOT software_type RADIOBASE ;
#IFNOT system_type ponto ;
public int print_string_aligned_right(char *t)
{
	cursor(get_cursor()-strlen(t));
	print_string(t);
}
#IFLESS system_version 700 ;
public int print_number_aligned_right2(int n)
{
	itoa(n,temp_string,10);
	print_string_aligned_right(temp_string);
}
#ENDIF ;
#ENDIF ;
#ENDIF ;

// -------------------------------------------------------------------------
// #IFLESS system_version 700 ;

public shift_left4(int n,int a)
{
	while(n)
	{
		a=a*2;
		n--;
	}
	return(a);
}
public write_cpu_register16(int register,int value)
{
	write_cpu_register32(CPU_REG4,value);
	write_cpu_register(register,read_cpu_register(CPU_REG4));
	write_cpu_register(register+1,read_cpu_register(CPU_REG4+1));
}
#IFNOT easy_conf 0 ;
#IFNOT system_type ponto XRML1 XRML2;
public shift_right4(int n,int a)
{
	while(n)
	{
		a=a/2;
		n--;
	}
	return(a);
}
#ENDIF ;
#ENDIF ;

// #ENDIF ;

/*
kmul4_by_4()
{
ASM	push_parameter 4	;
ASM	mul4			;
ASM	return		;
}

kmul4_by_3()
{
ASM	push_parameter 3	;
ASM	mul4			;
ASM	return		;
}

kmul4_by_2()
{
ASM	push_parameter 2	;
ASM	mul4			;
ASM	return		;
}
*/

// -------------------------------------------------------------------------

#IF compile_show_stack 1 ;
public show_stack()
{
	int b;
	push_variable(get_cursor());
	cursor(0);
	print_string("St:");
	b=read_cpu_register32(CPU_STACK)+8;
	print_number(b);
	print_string(" Sp:");
	b=read_cpu_register32(CPU_STACKb)+4;
	print_number(b);
	print_string("       ");
	cursor(pop_variable());
	really_update_screen();
	getch();
}
#ENDIF ;

// -------------------------------------------------------------------------
#IFNOT system_type ponto ;
public error(char *txt)
{
	cls();
	cursor_width(0);
	set_update_screen(1);
	set_display(0);
	print_string(txt);
	do
	{
	}
	while(getch()!=27);
}
public error_number(char *txt,int n)
{
	cls();
	cursor_width(0);
	set_update_screen(1);
	set_display(0);
	print_string(txt);print_number(n);
	do
	{
	}
	while(getch()!=27);
}
#ENDIF ;

// --------------------- Battery -------------------------------------------
#IF system_type horizontal ;
#IFNOT system_type RADIOBASE XRML1 XRML2;
public draw_bat()
{
	draw_bat2(battery_voltage());
}

public draw_bat2(int v)
{
//	min 4.0V Max 5.4V
//	    4000     5400
//	       0     1400

//	min 4.3V Max 5.4V
//	    4300     5400
//	       0     1100

//	min 4.3V Max 5.2V
//	    4300     5400
//	       0      900
#IF system_type rio vertical horizontal ;
#IFGREATEROREQUAL system_version 600 ;
		print_string("Bat.Volt. ");
		print_number(v);
		print_string("mV");
#ENDIF ;
#ENDIF ;

#IF system_type rio vertical horizontal ;
#IFLESS system_version 600 ;
		print_number(v);
		print_string("mV    ");
		v=v-critical_operation_voltage_limit_start;
		bar2(&v,5600-critical_operation_voltage_limit_start,8,1);
		print_char(22);
		print_char(23);
#ENDIF ;
#ENDIF ;

#IF system_type ponto ;
		print_string("DC Voltage ");
		print_number(v);
		print_string("mV");
#ENDIF ;
}

#ENDIF ;
#ENDIF ;


// ----------------------------------------------------------------------------------------------------------------------
#IF laser_type none ;
public laser_flush()
{
	char buffer[1];
}
#ENDIF ;

#IF system_type vertical ;
#IF laser_type symbol eia ;
public laser_flush()
{
	char buffer[32];
	int a;
	int n;
	write_cpu_register32(CPU_COM_TIMEOUT,5000);
	n=0;
	do
	{
		a=laser_read_byte();
		if( a<0 || a==13 )
		{
			break;
		}
		else
		{
			buffer[n]=a;
			n++;
		}
	}
	while(n<31);
	buffer[n]=0;
}

public laser_read_reply(char *txt,int timeout)
{
	int n;
	int a;
	int opcode;
	int checksum;
	int ch;
	int cl;

	write_cpu_register32(CPU_COM_TIMEOUT,timeout);

	n=laser_read_byte();					// length
	if(n<0)
	{
		return(-1);
	}
	checksum=n;

	opcode=laser_read_byte();				// opcode
	if(opcode<0)
	{
		return(-1);
	}
	checksum+=opcode;

	a=laser_read_byte();					// source
	if(a<0)
	{
		return(-1);
	}
	checksum+=a;

	a=laser_read_byte();					// status
	if(a<0)
	{
		return(-1);
	}
	checksum+=a;

	while(n>4)
	{
		a=laser_read_byte();
		if(a<0)
		{
			return(-1);
		}
		checksum+=a;
		if(txt)
		{
			*txt=a;
			txt++;
		}
		n--;
	}

	ch=laser_read_byte();
	if(ch<0)
	{
		return(-1);
	}

	cl=laser_read_byte();
	if(cl<0)
	{
		return(-1);
	}

	if( ch*256+cl != ( ( 0 - checksum ) & 65535 ) )
	{
		if(txt)
		{
			*txt=0;
		}
		return(-1);
	}

	return(opcode);
}

public laser_wake_up()
{	
	write_cpu_register(CPU_PORTB_VALUE,65296);			// BUG PIC 4.00 -
	laser_write_byte(0);
	delay(25000);				// 100ms
}

public laser_reset()
{	
	int n;
	write_cpu_register(CPU_PORTB_VALUE,65296);			// BUG PIC 4.00 -
	for(n=0;n<257;n++)
	{
		laser_write_byte(0);
	}
}

#define laser_retries				5

public laser_write_command(int n)
{
	int counter;
	int r;
	counter=laser_retries;
	r=0;
	do
	{
		if(r)
		{
			laser_reset();
			laser_wake_up();
		}
		if(!counter)
		{
			return(0);
		}
		write_cpu_register(CPU_PORTB_VALUE,65296);			// BUG PIC 4.00 -
		laser_write_byte(4);
		laser_write_byte(n);
		laser_write_byte(4);
		laser_write_byte(r);
		laser_write_byte( ( (-8-n-r) & 65280 ) / 256 );
		laser_write_byte(   (-8-n-r) & 255 );
		r=1;
		counter--;
	}
	while( laser_read_reply(0,25000)!=208 );
	return(1);
}

public laser_write_parameter(int p,int v,int eeprom)
{
							// eeprom = 8 -> write to eeprom
	int counter;
	int r;
	counter=laser_retries;
	r=0;
	do
	{
		if(r)
		{
			laser_reset();
			laser_wake_up();
		}
		if(!counter)
		{
			return(0);
		}
		write_cpu_register(CPU_PORTB_VALUE,65296);			// BUG PIC 4.00 -
		laser_write_byte(7);
		laser_write_byte(198);
		laser_write_byte(4);
		laser_write_byte(r+eeprom);
		laser_write_byte(255);
		laser_write_byte(p);
		laser_write_byte(v);
		laser_write_byte( ( (-464-r-8-p-v) & 65280 ) / 256 );
		laser_write_byte(   (-464-r-8-p-v) & 255 );
		r=1;
		counter--;
	}
	while( laser_read_reply(0,25000)!=208 );
	return(1);
}

#ENDIF ;

// -------------------------------------------------------------------------

#IF laser_type psc imageteam intermec ;
char laser_commands_buffer[20];
public laser_flush()
{
	char buffer[32];
	int a;
	int n;
	write_cpu_register32(CPU_COM_TIMEOUT,5000);
	n=0;
	do
	{
		a=laser_read_byte();
		if( a<0 || a==13 )
		{
			break;
		}
		else
		{
			buffer[n]=a;
			n++;
		}
	}
	while(n<31);
	buffer[n]=0;
}

#ENDIF ;
#IF laser_type psc intermec ;

public get_laser_model()
{
	int ct;

	push_variable(baud_func_set_baud_rate2);
	push_variable(read_cpu_register(CPU_COMPORT_MASK));
	write_cpu_register(CPU_COMPORT_MASK,32);

	set_baud_rate2(19200);

	write_cpu_register(5,65280-32768);					// Trigger 0
	delay(25000);	
	write_cpu_register(CPU_COMBUFFER_GET,0);
	write_cpu_register(CPU_COMBUFFER_SAVE,0);

	laser_write_byte(2);
	laser_write_byte(36);
	laser_write_byte(67);
	laser_write_byte(48);
	laser_write_byte(130);
	laser_write_byte(98);
	laser_write_byte(16);
	laser_write_byte(67);
	laser_write_byte(182);
	laser_write_byte(3);

	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	// 2 36 6 0 3
	// 2 36 83 48 130 16 66 6 104 6 96 3	( 16 66 -> Modelo)
	
	ct=0;
	do									// Esvaziar buffer e ignora resposta.!!!
	{
		ct++;
	}
	while( laser_read_byte()>=0 );

	write_cpu_register(5,65280+128);			// Trigger 1

	if(ct==18)
	{
		hardware_is_laser_intermec=1;
	}
	else
	{
		hardware_is_laser_intermec=0;
	}
	
	write_cpu_register(CPU_COMPORT_MASK,pop_variable());
	set_baud_rate2(pop_variable());
	return(1);								
}

public laser_calculate_checksum(char *data,int size)
{
	int n,chk,ct;
	chk=0;
	for(n=size;n>0;n--)
	{
		chk+=((*data) * n);
		data++;
	}
	return(chk);	
}

public laser_write_byte_dle(int byte)
{
	if(byte!=2 && byte!=3 && byte!=16)
	{
		laser_write_byte(byte);
	}
	else
	{
		laser_write_byte(16);
		laser_write_byte(byte+64);
	}	
	
}

public laser_write_command(char *txt,int timeout,int counter)
{
	int ptr;
	char *chk;
	int chk1;
	int size,bits;
	if(hardware_is_laser_intermec)
	{
		push_variable(baud_func_set_baud_rate2);
		push_variable(read_cpu_register(CPU_COMPORT_MASK));
		write_cpu_register(CPU_COMPORT_MASK,32);
		
		set_baud_rate2(19200);

		write_cpu_register(5,65280-32768);					// Trigger 0
		delay(25000);	
		do
		{
			while(laser_read_byte() != -1 )
			{
			}		

			if(!counter)
			{
				write_cpu_register(CPU_COMPORT_MASK,pop_variable());
				set_baud_rate2(pop_variable());
				return(0);
			}
			laser_write_byte(2);						// <STX>
											// <SN> Seq. Number
											// <TYPE> 
											// <DATA>
			if(txt[1]==67)
			{
				bits=0;
			}
			else
			{
				bits=(txt[3] & 192)/64;					// <FID> bit 6 e bit 7
			}
			if(bits<3)
			{
				size=5+bits;
			}
			else
			{
				size=strlen(txt);
			}
			push_variable(size);
		
			ptr=0;
			do
			{
				laser_write_byte_dle(txt[ptr]);
				ptr++;
				size--;
			}
			while(size>0);
			
			size=pop_variable();
			chk1=laser_calculate_checksum(txt,size);
			chk=&chk1;
			laser_write_byte_dle(*(chk+1));					// <CHK> 2 Bytes
			laser_write_byte_dle(*(chk));					// <CHK> 2 Bytes

			laser_write_byte(3);						// <ETX>
			counter--;
			write_cpu_register32(CPU_COM_TIMEOUT,timeout);

		}
		while( laser_read_byte() != 2 );
		write_cpu_register(CPU_COMPORT_MASK,pop_variable());
		set_baud_rate2(pop_variable());
	}
	else
	{
		do
		{
			if(!counter)
			{
				return(0);
			}
	
			write_cpu_register(CPU_PORTB_VALUE,65296);			// BUG PIC 4.00 -
			laser_write_byte(2);
			laser_write_byte(27);
			ptr=0;
			while(txt[ptr])
			{
				laser_write_byte(txt[ptr]);
				ptr++;
			}
			laser_write_byte(3);
			counter--;
			write_cpu_register32(CPU_COM_TIMEOUT,timeout);
		}
		while( laser_read_byte() != 6 );
	}
	return(1);
}

#ENDIF ;

#IF laser_type imageteam ;

int photography;

public laser_write_command(char *txt,int timeout,int counter)
{
	int ptr,ptr2,c;
	char result[20];
	
	//cls();
	//beep(400,400);
	
//	do
//	{
		if(!counter)
		{
			return(0);
		}

		laser_write_byte(22);
		laser_write_byte(77);
		laser_write_byte(13);
		ptr=0;
		while(txt[ptr])
		{
			laser_write_byte(txt[ptr]);
			ptr++;
		}
		counter--;

		write_cpu_register32(CPU_COM_TIMEOUT,timeout);
		ptr=0;
		while(txt[ptr])
		{
			c=laser_read_byte();
			if(c<0)
			{
				break;
			}
			//putch(c);

			if(c==txt[ptr])
			{
				ptr++;
			}
			else
			{
				if( txt[ptr]=='.' || txt[ptr]=='!' || txt[ptr]==',' || txt[ptr]==';' )
				{
					ptr2=0;
					while( c!=txt[ptr] )
					{
						result[ptr2]=c;
						ptr2++;
	
						c=laser_read_byte();
						if(c<0)
						{
							print_string(txt);
							beep(10,500);
							return(0);
						}
						//putch(c);		
					}
					result[ptr2]=0;
					if(result[ptr2-1]==6)
					{
						//beep(100,100);
						return(1);
					}
				}
			}
		}
					
//	}
//	while( 1 );

	print_string(txt);
	beep(10,500);
	return(0);
}

#ENDIF ;

// --------------------------------------------------------------------------

#IF laser_type symbol ;
public laser_set_default_parameters()
{
									// write once, save in eeprom
	int done;

	if(done)
	{
		return;
	}

	if( laser_write_parameter(104,13,8) == 0 )			// sufix 13
	{
		return(0);
	}

	if( laser_write_parameter(235,1,8) == 0 )			// sufix ON
	{
		return(0);
	}

	if( laser_write_parameter(136,50,8) == 0 )		// Laser ON Time
	{
		return(0);
	}

	if( laser_write_parameter(138,8,8) == 0 )			// Laser Host Triggered
	{
		return(0);
	}

	if( laser_write_parameter(128,1,8) == 0 )			// powersave ON
	{
		return(0);
	}

//	if( laser_write_parameter(78,2,8) == 0 )				// security level 2
//	{
//		return(0);
//	}

//	if( laser_write_parameter(43,1,8) == 0 )				// bi-directional redundancy
//	{
//		return(0);
//	}

//	if( laser_write_parameter(48,1,8) == 0 )				// code39 checksum enabled
//	{
//		return(0);
//	}

	done=1;
}
#ENDIF ;

#IF laser_type symbol_ ;
public laser_set_default_parameters()
{
									// write everytime, don't save in eeprom
	int done;

	if( laser_write_parameter(104,13,0) == 0 )			// sufix 13
	{
		return(0);
	}

	if( laser_write_parameter(235,1,0) == 0 )			// sufix ON
	{
		return(0);
	}

	if( laser_write_parameter(136,50,0) == 0 )			// Laser ON Time
	{
		return(0);
	}

	if( laser_write_parameter(138,8,0) == 0 )			// Laser Host Triggered
	{
		return(0);
	}

	if( laser_write_parameter(128,1,0) == 0 )			// powersave ON
	{
		return(0);
	}

//	if( laser_write_parameter(78,2,0) == 0 )				// security level 2
//	{
//		return(0);
//	}

//	if( laser_write_parameter(43,1,0) == 0 )				// bi-directional redundancy
//	{
//		return(0);
//	}

//	if( laser_write_parameter(48,1,0) == 0 )				// code39 checksum enabled
//	{
//		return(0);
//	}

	done=1;
}
#ENDIF ;

// --------------------------------------------------------------------------

#IF laser_type psc intermec;
int laser_set_default_extra_parameters;
public laser_set_default_parameters()
{
	int done;

	if(hardware_is_laser_intermec)
	{
		if(!done)
		{
/*		
			laser_commands_buffer[0]=1;				// SN			01
			laser_commands_buffer[1]=65;				// TYPE		41
			laser_commands_buffer[2]=75;				// SG			4B
			laser_commands_buffer[3]=67;				// PARAM 2		43
			laser_commands_buffer[4]=1;				// PARAM 3		1
			laser_commands_buffer[5]=96;				// FM			60
		
			if( !laser_write_command(laser_commands_buffer,25000,1) )				// 
			{
				beep(50,50);
				beep(100,100);
				beep(50,50);
				beep(100,100);
				beep(50,50);
				beep(500,500);
				return(0);
			}
									
			delay(200000);										//	???
			write_cpu_register32(CPU_COM_TIMEOUT,10000);
			
			while( laser_read_byte() !=-1 )									// Esvaziar buffer e ignora resposta.!!!
			{
				delay(5000);
			}
			beep(200,200);
*/
		}
	}
	else
	{
		laser_commands_buffer[0]='L';
		laser_commands_buffer[1]='B';
		laser_commands_buffer[2]=13;
		laser_commands_buffer[3]=0;
	
		if(!done)
		{
	
			if( !laser_write_command("@1",25000,10) )			// Batch programming mode
			{
				return(0);
			}
	
	
			if( !laser_write_command(laser_commands_buffer,25000,25) )			// sufix 13
			{
				return(0);
			}
	
	
			if(laser_set_default_extra_parameters)
			{
				 if(laser_set_default_extra_parameters()==0)
				 {
				 	return(0);	
				 }
			}
	
			if( !laser_write_command("@2",75000,10) )			// Batch programming mode OFF
			{
				return(0);
			}	
		}
	}
	done=1;
	return(1);
}
#ENDIF ;



#IF laser_type none ;
public laser_set_default_parameters()
{
}
#ENDIF ;
#ENDIF ;

// -------------------------------------------------------------------------

#define keyboard_buffer_size 64
#define keyboard_buffer_mask 63
char keyboard_buffer[keyboard_buffer_size];
int scancode_buffer[keyboard_buffer_size];

public int keyboard_save_in_buffer(int key,int scancode)
{
	int ptr_save;
	int ptr_read;
	if(!key)
	{
		return(0);
	}
	if( (ptr_save-ptr_read) >= keyboard_buffer_mask )
	{
		return(0);
	}
	keyboard_buffer[ptr_save&keyboard_buffer_mask]=key;
	scancode_buffer[ptr_save&keyboard_buffer_mask]=scancode;
	ptr_save++;
	return(1);
}

public int keyboard_read_from_buffer(int advance)
{
	int ascii;
	if( ptr_save_func_keyboard_save_in_buffer <= ptr_read_func_keyboard_save_in_buffer )
	{
		return(0);
	}
	ascii=keyboard_buffer[ptr_read_func_keyboard_save_in_buffer&keyboard_buffer_mask];
	if(advance)
	{
		ptr_read_func_keyboard_save_in_buffer++;
	}
	if(ascii)
	{
		return(ascii);
	}
	else
	{
		return('?');
	}
}

public int keyboard_read_last_from_buffer()
{
	if(ptr_read_func_keyboard_save_in_buffer>0)
	{
		return(keyboard_buffer[ (ptr_read_func_keyboard_save_in_buffer-1) & keyboard_buffer_mask]);
	}
	return(0);
}

public int keyboard_unread_from_buffer(int key,int code)
{
	if(!key)
	{
		return(0);
	}

	if(ptr_read_func_keyboard_save_in_buffer!=0 )
	{
		ptr_read_func_keyboard_save_in_buffer--;
	}


	keyboard_buffer[ptr_read_func_keyboard_save_in_buffer&keyboard_buffer_mask]=key;
	scancode_buffer[ptr_read_func_keyboard_save_in_buffer&keyboard_buffer_mask]=code;
}

public int flush_keyboard_buffer()
{
	ptr_save_func_keyboard_save_in_buffer=keyboard_buffer_mask;
	ptr_read_func_keyboard_save_in_buffer=keyboard_buffer_mask;
	keyboard_buffer[keyboard_buffer_mask]=0;
}

// -------------------------------------------------------------------------

#IF compile_debug_number 1 ;
int	debug_numberz[32];


debug_number(int x)
{
int 	ct;

	debug_numberz[ct & 31]=x;
	ct++;
	debug_numberz[ct & 31]=0;
}
#ENDIF ;

// -------------------------------------------------------------------------

int new_lcd;

set_new_lcd()
{
#IF compile_new_lcd 1 ;
	if(new_lcd==79)
	{
		write_lcd_command(68);
		write_lcd_command(32);
		write_lcd_command(147);
		write_lcd_command(38);
		write_lcd_command(56);
		write_lcd_command(240);
	}
/*
	write_cpu_register(37,157);
	write_cpu_register(38,read_cpu_register(53)|17);
	write_cpu_register(39,read_cpu_register(48)&128));
	write_cpu_register(40,2*read_cpu_register(48));
	write_cpu_register(41,read_cpu_register(CPU_DX));
	write_cpu_register(42,read_cpu_register(CPU_DX+1));
*/
#ENDIF ;
}

// -------------------------------------------------------------------------

#IF gps_type fastrax ;

int gps_power;

int secure_read(int p)
{
	int n;
	int r;
	r=0;
	for(n=0;n<50;n++)
	{
		r=r|read_cpu_register(3968);
	}
	return(r);
}

set_gps_power(int p)
{
	int timeout;
	timeout=100;
	write_cpu_register(3986,255*256+16);
	if(p>0)
	{
		do
		{
			if(secure_read(3968)&16)
			{
				break;
			}
			press_gps_standby_switch();
			timeout--;
		}
		while(timeout);
	}
	else
	{
		do
		{
			if((secure_read(3968)&16)==0)
			{
				break;
			}
			press_gps_standby_switch();
			timeout--;
		}
		while(timeout);
	}
	if(timeout==0)
	{
		p=0;	
	}
	if(p>=0)
	{
		gps_power=p;
	}
}

press_gps_standby_switch()
{
	write_cpu_register(3977,256*255+2);
	delay(ONESECOND/10);
	write_cpu_register(3977,256*(255-2));
	delay(ONESECOND/2);
}

gps_wait_for_fix_menu(int a,int b,int c)
{
	if(!drawing_form)
	{
		if(getch()==13)
		{
			gps_wait_for_fix(a);
		}
	}
	return(26);
}

gps_wait_for_fix(int r)
{
	struct GPS_DATA gps;
	int bad_counter;
	int aux;

	set_gps_power(1);

	bad_counter=0;
	do
	{
		beep(10,10);

		if(read_gps_data(&gps))
		{
			set_update_screen(0);
			set_display(0);
			cls();
			putch(254);
			print_string("Downloading satellite data");
			new_line();
			print_number(gps.valid);
			putch('.');
			print_number(gps.satellites);
			putch('.');
			print_number(gps.precision);
			new_line();
			print_string("Time:");
			print_string(gps.time);
/*
			new_line();							// nao estou a ler a data
			print_string("Date:");
			print_string(gps.date);
*/
			new_line();
			print_string("Lati:");
			print_string(gps.latitude);
			new_line();
			print_string("Long:");
			print_string(gps.longitude);
			new_line();
			print_string("Alti:");
			print_string(gps.altitude);
			new_line();
			print_string("Cntr:");
			print_number(bad_counter);
			set_update_screen(1);
			update_screen();
			if(gps.valid)
			{
				beep(100,100);
				bad_counter=0;
				if(r)
				{
					return(1);
				}
			}
			else
			{
				bad_counter++;
			}
		}

	}
	while(sensech()!=ESCKEY);

}

read_gps_data(struct GPS_DATA *gps)
{
	//char buffer[512];
	char buffer[1024];
	char *ptr,*ptr2;
	int c;

	if(!gps_power)
	{
		delay(25000);
		return(0);
	}

	c=read_gps_bytes(buffer);
	buffer[c]=0;

	if(c<100)
	{
		return(0);
	}

	if(c>1024)
	{
		cls();
		print_string("read_gps_data error!!!");
		beep(1000,1000);
		return(0);
	}


	ptr=strstr(buffer,"$GPGGA");
	if(!ptr)
	{
		return(0);
	}
	ptr+=6;


// get time
	ptr=strchr(ptr,',');
	if(!ptr)
	{
		return(0);
	}
	ptr++;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}
	*ptr2=0;

	strcpy(gps->time,ptr);

// get latitude
	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}
	ptr2=strchr(ptr2+1,',');
	if(!ptr2)
	{
		return(0);
	}
	*ptr2=0;

	strcpy(gps->latitude,ptr);

// get longitude
	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}
	ptr2=strchr(ptr2+1,',');
	if(!ptr2)
	{
		return(0);
	}
	*ptr2=0;

	strcpy(gps->longitude,ptr);

// get valid
	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}

	gps->valid=pic_atoi(ptr);

// get satellites
	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}

	gps->satellites=pic_atoi(ptr);

// get precision
	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}

	gps->precision=pic_atoi(ptr);

// get altitude

	ptr=ptr2+1;

	ptr2=strchr(ptr,',');
	if(!ptr2)
	{
		return(0);
	}
	*ptr2=0;

	strcpy(gps->altitude,ptr);

	return(gps->valid+1);
}


#ENDIF ;

// --------------------- Call main() ---------------------------------------

sysmain()
{
	int aux;
	int reset_counter;
	int program_changed_by_dll;

#IF tag_type TagIt Calypso Rfid125;
	disable_rfid_reading();
#ENDIF ;



// --------------------- Setup LCD -----------------------------------------

	set_display_buffer(0,4000,80);
	screen_format=0;
	title_lines=0;
	debug_lines=0;
	set_display(0);
	cls();

#IF compile_debug_number 1 ;
int n;
	if(inkey()==257)
	{
		cls();
		for(n=0;n<32;n++)
		{
			print_number(debug_numberz[n]);print_string(",");
			if((n&3	)==3)
			{
				new_line();
			}
		}
		really_update_screen();

		getch();
		while(inkey())
		{
		}
		getch();
	}
#ENDIF;

#IF tag_type TagIt ;
	enable_rfid_reading();
	delay(50000);
	initialize_rfid();
	delay(50000);
	disable_rfid_reading();
	tagMifare=0;
#ENDIF ;

	aux=(end_all_program_blocks+1024) - read_cpu_register32(CPU_STACK);
	if(aux>0)
	{
		print_string("Out of RAM ");
		putch('(');
		print_number(aux);
		putch(')');
		do
		{
			pic_wait_event(1,0);
			set_new_lcd();
		}
		while(1);
	}

	if(read_cpu_register(31)==254)
	{
		write_cpu_register(31,0);
		write_cpu_register(CPU_STARTUP_CODE,3);
	}

cold_start:
//	Startup Code
//	1			RAM
//	2			EEPROM
//	3			COM/RADIO

#IF compile_debug_trace 1 ;
	debug_trace_on=0;
#ENDIF ;

// --------------------- Clear RAM -----------------------------------------

	if( startup_test!=12345678 || read_cpu_register(CPU_STARTUP_CODE) != 1 ) // Se no arrancou de RAM
	{
		print_string("Clearing RAM");
		push_variable(program_checksum);
		memset(end_initialized_program_blocks,0,end_all_program_blocks-end_initialized_program_blocks);
		startup_test=12345678;
		program_checksum = pop_variable();
		cls();

		value_func_pic_version=0;
		pic_version();

		battery_charge=64;
	}

// --------------------- Desligar GPRS -------------------------------

#IF radio_type gprs ;
	
	if(gsm_error)
	{	
		cls();
		print_string("Fixing GPRS");
		beep(200,200);	
		gsm_reset
		delay(ONESECOND/5);
		gsm_standby
		delay(ONESECOND/5);

		write_cpu_register(4015,(20000000/64/9600));			// BaudRate 9600	
		gprs_disconnect_hardware();			
		gsm_error=0;
	}
	else
	{
		write_cpu_register(4011,256*(255-128-16));			// desliga porta serie
		write_cpu_register(4012,256*(255-32-4));			// e 
		write_cpu_register(3988,256*255+64);				// TXD de radio como entrada
	}

#ENDIF ;
// --------------------- Setup Hardware Type -------------------------------

	if(read_cpu_register(0)&128)
	{
		hardware_is_pricechecker=1;
	}

	hardware_is_ementa=hardware_is_ementa_define;

	if(value_func_pic_version==787)
	{
		if(read_cpu_register(0)&8)
		{
			write_cpu_register(4011,256*(255-128));
		}
	}

	function_func_getch2=def_getch2_function;

#IF software_type RADIOBASE ;
	if(value_func_pic_version<750)
	{
//		portb_value=CPU_PORTB_VALUE;
//		ddrb_value=CPU_DDRB_VALUE;
	}
	else
	{
//		portb_value=3978;
//		ddrb_value=3987;
		if(value_func_pic_version<780)
		{
			write_cpu_register(0,256*(255-8));
			write_cpu_register(3988,256*255+128);
		}
	}
#ELSE;
	if(value_func_pic_version>=750)
	{
		if(value_func_pic_version<780)
		{
			write_cpu_register(0,256*(255-8));
			write_cpu_register(3988,256*255+128);
		}
	}
#ENDIF ;

#IF calculator_floats 1 ;
	decimal_points=-1;
#ENDIF ;

	set_display_buffer(0,4000,80);
	screen_format=0;
	set_display(0);
	cls();

#IF system_type rio horizontal ;
	if(lcd_contrast>0)
	{
		set_lcd_contrast(lcd_contrast-1);
	}
	else
	{
		set_lcd_contrast(16);
	}
#ENDIF ;

#IF system_type vertical ;
	if( lcd_contrast>0 && lcd_contrast<17 )
	{
		set_lcd_contrast(lcd_contrast-1);
	}
	else
	{
		if(value_func_pic_version>=715)
		{
			set_lcd_contrast(DEFAULT_X64_LCD_CONTRAST);
		}
		else
		{
			set_lcd_contrast(DEFAULT_DENSITRON_LCD_CONTRAST);
		}
	}
#IF laser_type symbol psc eia intermec ;
	*buffer_func_laser_flush=0;
#ENDIF ;
#ENDIF ;

	next_update_func_power_off_countdown=0;

	power_is_off=0;

	reset_counter++;

	title_lines=0;

#IFNOT system_type ponto ;
	set_function_keys("",1);
#ENDIF ;

#IF debug 1 ;
//	critical_operation_voltage_limit=-9999999;
#ENDIF ;

#IFNOT radio_type irab ;
#IF system_type rio ;
#IFGREATEROREQUAL system_version 300 ;
	write_cpu_register(CPU_COM_RECEIVE_NOT_READY,59136+24);
	write_cpu_register(CPU_COM_RECEIVE_READY,59136+24);
#ENDIF ;
#ENDIF ;
#ENDIF ;

	set_configuration_defaults();

	aux=load_configuration_data();
	if(inkey()==338)
	{
		new_lcd=79;
		aux=0;
		beep(200,200);
		delay(50000);
		beep(200,200);
	}
	if(inkey()==345)
	{
		new_lcd=0;
		aux=0;
		beep(200,200);
	}
	set_new_lcd();
	while(inkey())
	{
	}
	if(!aux)
	{
		save_configuration_data();
#IF system_type ponto ;
		set_terminal_id("PONTO_00");
#ENDIF ;
#IFNOT system_type ponto ;
//		set_terminal_id("TEST0 01");
#ENDIF ;
#IF software_type RADIOBASE ;
		set_terminal_id("BAS00");
#ENDIF ;
	}

	reset_multitap();

#IF gps_type fastrax ;
	cls();
	print_string("Waiting GPS");
	beep(1,1);
	set_gps_power(0);
#ENDIF ;

// --------------------- Setup Radio ---------------------------------------

#IFNOT system_type ponto ;
#IFNOT radio_type none ;
#IFNOT radio_type gprs ;
	init_radio();
#ENDIF ;
#ENDIF ;
#ENDIF ;

	//set_radio_channel("BAS00");

#IFNOT radio_type gprs ;
#IFNOT radio_type none ;
	set_radio_channel(work_base_id);

	if(value_func_pic_version>=750&&value_func_pic_version<796)
	{
		write_cpu_register(162,16);			// CPU_NORDIC_HEADER_SIZE, 7 mal; 8 OK; 16 seguro; 32 esta no PIC
	}
#ENDIF ;
#ENDIF ;
#IF compile_com_message 1 ;
	choose_baud_rate(index_func_choose_baud_rate);
#IF software_type AS400 XRML1 XRML2 RADIOBASE ;
	change_type_of_connection(0);						// Comunication variables
#ENDIF ;
#ENDIF ;

	MessageIdCount=0;
	RetransmitType=0;
	BlockIncrNumber=0;	
	*ExpectedBlockId=0;
	confirmations_timeout=confirmation_timeout;

									// Para ser alterado pela dll, quando o programa  enviado automaticamente.
									// se arrancou de Serie ou Radio
	if(read_cpu_register(CPU_STARTUP_CODE) == 3)
	{		
		if(strcmp("DllDataxpto","DllDataxpto"))
		{
			program_changed_by_dll=1;
			strcpy(work_base_id,"WORXBASE");
			strcpy(terminal_id,"WORXTERM");
			if(!strcmp(terminal_id,"WORXTERM"))
			{
				strcpy(terminal_id,"00");
				itoa((get_seconds() & 255) * 256 + (get_serial_number() & 255)+1000,terminal_id+2,10);
				strcpy(terminal_id+6,"98");
			}
			set_terminal_id(terminal_id);
		}
	}

											// End Comunication variables
	write_cpu_register32(CPU_RADIO_SYNC_READ_SIZE,8);

	set_terminal_id(terminal_id_in_eeprom);
	set_terminal_id(terminal_id);

	lcd_light_state=-5;

	shift_key=0;
	release_key=0;
	caps_lock=0;
	cursor_height(128);
	inside_os_menu=0;
	cursor_width(1);
	space_in_text=' ';

#IFNOT software_type RADIOBASE ;
#IFNOT debug 1 ;
#IFGREATER system_version 400 ;
	if( system_version/100 > value_func_pic_version/100 )
	{
		cls();
		print_string("Wrong Version ");
		print_number(system_version/100);
		putch('-');
		print_number(value_func_pic_version/100);
		while(1)
		{
			getch();
		}
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;

	power_off_countdown_restart();
	cls();

#IFNOT system_type ponto ;
#IF compile_malloc 1 ;
	init_malloc
	init_memory_allocation();
#ENDIF ;
#ENDIF ;

#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 708 ;
#IFNOT force_no_16c71_reset 1 ;
	
	if(startup_test2==12345678)
	{
		print_string("Upgrade Error");
		while(!inkey())
		{
		}
	}
	startup_test2=12345678;
	correct_16c71_reset();
	startup_test2=0;

#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;

	//battery_charge=battery_charge|1;
	battery_voltage();
#IFNOT system_type ponto ;
	update_battery_check_discharge();
#ENDIF ;

#IFNOT software_type RADIOBASE ;
#IFNOT system_type horizontal ;
	set_external_keyboard_power(0);
#ENDIF ;
#ENDIF ;

#IF system_type vertical ;

#IF laser_type symbol ;
	done_func_laser_set_default_parameters=0;
#ENDIF ;

#IF laser_type psc intermec;
	done_func_laser_set_default_parameters=0;
	get_laser_model();
#ENDIF ;

#ENDIF ;

#IF system_type vertical horizontal ;
#IF reseller pie ;
	reseller_logo();
#ENDIF ;
#ENDIF ;

#IFNOT system_type ponto ;
#IFNOT software_type RADIOBASE ;
#IFNOT debug 1 ;

/*
//???
int n;
int file;
n=11111;
file=fopen("config","wb")-4;
fwrite(&n,1,4,&file);
fclose(&file);
*/
	if(!hardware_is_pricechecker)
	{
		while(!get_serial_number())
		{
			cls();
			print_string("SerialNumber");
			set_serial_number(0);
		}
	}

#ENDIF ;
#ENDIF ;
#ENDIF ;

	disable_com_port_enable_timer();

#IFNOT software_type ponto ;
	for(aux=0;aux<8;aux++)
	{
		seed_func_rnd+=terminal_id[aux];
		seed_func_rnd=seed_func_rnd*get_seconds()*39861293876;
	}
#ENDIF ;

	if( startup_test!=12345678 || read_cpu_register(CPU_STARTUP_CODE) != 1 ) // Se no arrancou de RAM
	{
		battery_voltage();
		update_battery_check_discharge();
		battery_voltage();
		update_battery_check_discharge();
		battery_voltage();
		update_battery_check_discharge();
		last_battery_charge=battery_charge;
	}

	voltage_func_power_off_countdown=battery_voltage();
	if(read_cpu_register(CPU_STARTUP_CODE)!=3)
	{
		power_off_countdown();
	}

	while(sensech())
	{
		getch();
	}

	main();

#IF software_type osx64 ;
	goto cold_start;
#ENDIF ;

#IFNOT software_type RADIOBASE ;
	set_external_keyboard_power(0);
#ENDIF ;

//	show_stack();
}

// -------------------------------------------------------------------------

#IF system_type horizontal ;
#IF compile_sprites 1 ;
public enable_sprites()
{
	memset(print_ram,250,print_width*print_height);
}
public print_sprite(char *buffer, int x, int y, int type)
{
	int line;
	for(line=0;line<buffer[1];line++)
	{
		write_lcd_command(184|(line+y));
		write_lcd_command(x);
		write_cpu_register(CPU_REGDEL1,0);
		write_cpu_register(CPU_LCD_CONTROL,(255-4-2)*256+2);
		write_cpu_register(CPU_REGDEL5,0);
		write_cpu_register(CPU_REGDEL6,0);
		write_cpu_register(CPU_REGDEL8,255);
		write_cpu_register(CPU_PIXEL_COUNTER,62-x);
		memcpy( (128+64)*256*256, buffer+3+line*buffer[0], buffer[0] );
	}
}
#ENDIF ;
#ENDIF ;

#IF compile_sprites 1 ;
#IF system_type vertical ;
public enable_sprites()
{
	memset(print_ram,250,print_width*print_height);
}
public print_sprite_at_character_line(char *buffer, int x, int y)
{
	int line;
	for(line=0;line<buffer[1];line++)
	{
		write_lcd_command( 176 | (line+y) );
		write_lcd_command(     (x+33)     & 15 );
		write_lcd_command( ( ( (x+33)/16) & 15 ) | 16 );
		write_cpu_register(CPU_REGDEL1,0);
		write_cpu_register(CPU_LCD_CONTROL,(255-4-2)*256+2);
		write_cpu_register(CPU_REGDEL5,0);
		write_cpu_register(CPU_REGDEL6,0);
		write_cpu_register(CPU_REGDEL8,255);
		write_cpu_register(CPU_PIXEL_COUNTER,100-x);
		memcpy( (128+64)*256*256, buffer+3+line*buffer[0], buffer[0] );
	}
}
#ENDIF ;
#ENDIF ;

#IF compile_sprites 1 ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;

public read_sprite(char *buffer, int x, int y)
{
											// 64 write
											// 16 or
											// 32 and
											// 8 and or
	int line;

	// int yy;
	// yy=y&7;

	buffer[2]=y&7;

	y=y/8;
	
	for(line=0;line<buffer[1];line++)
	{
		write_lcd_command( 176 | (line+y) );
		write_lcd_command(     (x+33)     & 15 );
		write_lcd_command( ( ( (x+33)/16) & 15 ) | 16 );
		cpylcdram(buffer+3+line*buffer[0], buffer[0] );
	}
}

public print_sprite(char *buffer, int x, int y, int type)
{
											// 64 write
											// 16 or
											// 32 and
											// 8 and or
	int line;
	int yy;

	if(value_func_pic_version<718)
	{
		x+=33;
	}

	yy=y&7;
	y=y/8;

	if(buffer[2]==255)
	{
		buffer+=yy*(3+buffer[0]*buffer[1]);
	}
	else
	{
		if( yy != buffer[2] )
		{
			adjust_sprite_y(buffer,yy);
		}
	}
	
	for(line=0;line<buffer[1];line++)
	{
		write_lcd_command( 176 | (line+y) );
		write_lcd_command(    x       & 15 );
		write_lcd_command( ( (x/16) & 15 ) | 16 );

		if(type!=WRITE_SPRITE)
		{
			write_lcd_command(128+64+32);
		}
		cpyramlcd(type, buffer+3+line*buffer[0], buffer[0] );
		if(type!=WRITE_SPRITE)
		{
			write_lcd_command(128+64+32+2+4+8);
		}
	}
}

public adjust_sprite_y(char *buffer,int yy)
{
	int x,y;
	int shift;
	int nx,nx2;
	
	nx=buffer[0];
	nx2=2*nx;
	
	if(yy>buffer[2])
	{
		shift=yy-buffer[2];

		if(buffer[1]>=3)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x+nx2] = ( buffer[3+x+nx2] << shift ) | ( ( buffer[3+x+nx] << shift ) >> 8 );
			}
		}
		if(buffer[1]>=2)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x+nx] = ( buffer[3+x+nx] << shift ) | ( ( buffer[3+x] << shift ) >> 8 );
			}
		}
		if(buffer[1]>=1)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x]=buffer[3+x] << shift;
			}
		}
	}
	
	if(buffer[2]>yy)
	{
		shift=buffer[2]-yy;

		if(buffer[1]>=1)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x]=buffer[3+x] >> shift | ( ( buffer[3+x+nx] << 8 ) >> shift );
			}
		}
		if(buffer[1]>=2)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x+nx] = ( buffer[3+x+nx] >> shift ) | ( ( buffer[3+x+nx2] << 8 ) >> shift );
			}
		}
		if(buffer[1]>=3)
		{
			for(x=0;x<nx;x++)
			{
				buffer[3+x+nx2] = ( buffer[3+x+nx2] >> shift );
			}
		}
	}
	
	buffer[2]=yy;
}

int make_fast_sprite(char *sp)
{
	int nx,ny;
	char *ptr;
	int n;

	nx=sp[0];
	ny=sp[1];
	
	ptr=malloc(8*(3+nx*ny));
	for(n=0;n<7;n++)
	{
		memcpy(ptr+n*(3+nx*ny),sp,3+nx*ny);
		adjust_sprite_y(ptr+n*(3+nx*ny),n);
	}
	ptr[2]=255;
	return(ptr);
}

#ENDIF ;
#ENDIF ;
#ENDIF ;

// -------------------------------------------------------------------------

#IF system_type vertical ;
#IF reseller pie ;
#include	"pie.c"
reseller_logo()
{
	cls();
	enable_sprites();
	print_sprite(pie_graphics,40,0,WRITE_SPRITE);
	cursor(3*display_width+2);
	print_string("www.grupopie.com");
	delay(1048576);
}
#ENDIF ;
#ENDIF ;

#IF system_type horizontal ;
#IF reseller pie ;
#include	"pie.c"
reseller_logo()
{
	cls();
	enable_sprites();
	print_sprite(pie_graphics,50,0,WRITE_SPRITE);
	cursor(3*display_width+4);
	print_string("www.grupopie.com");
	delay(1048576);
}
#ENDIF ;
#ENDIF ;

#IFNOT software_type AS400 ;
public myinput()
{
}
#ENDIF ;

// --------------------------------------------------------------------------

#IF compile_leds 1 ;

#define	LED_OFF		set_led_off();
#define	LED_RED		set_led_red();
#define	LED_GREEN	set_led_green();
#define	LED_ORANGE	set_led_orange();

/*
public pisca_led(int n)
{
	int x;
	for(x=0;x<n;x++)
	{
		LED_ORANGE
		beep(400,120);
		LED_OFF
		delay(50000);
	}	
	delay(500000);
}
*/

set_led_green()
{
	if(value_func_pic_version<750)
	{
		write_cpu_register(CPU_DDRB_VALUE,52992);
		write_cpu_register(CPU_PORTB_VALUE,52992+32);
	}
	else
	{
		write_cpu_register(3978,256*(255-32-16)+32);
	}
}

set_led_orange()
{
	if(value_func_pic_version<750)
	{
		write_cpu_register(CPU_DDRB_VALUE,52992);
		write_cpu_register(CPU_PORTB_VALUE,52992+48);
	}
	else
	{
		write_cpu_register(3978,256*(255-32-16)+32+16);
	}
}

set_led_red()
{
	if(value_func_pic_version<750)
	{
		write_cpu_register(CPU_DDRB_VALUE,52992);
		write_cpu_register(CPU_PORTB_VALUE,52992+16);
	}
	else
	{
		write_cpu_register(3978,256*(255-32-16)+16);
	}
}

set_led_off()
{
	if(value_func_pic_version<750)
	{
		write_cpu_register(CPU_DDRB_VALUE,52992);
		write_cpu_register(CPU_PORTB_VALUE,52992);
	}
	else
	{
		write_cpu_register(3978,256*(255-32-16));
	}
}

#ENDIF ;

// --------------------------------------------------------------------------

public int read_ram32(char *i)
{
	return( *(i+3)*16777216 + *(i+2)*65536 + *(i+1)*256 + *i );
}

public call_function(char *v)
{
	if(v)
	{
		return(v());
	}
}

// -------------------------------------------------------------------------

disable_com_port_enable_timer()
{
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	int time;
	int timer_enabled;
	if( value_func_pic_version>=700 && value_func_pic_version<=710 )
	{
		if(!com_enabled_all_the_time)
		{
			//write_cpu_register(23+65536,0);				// disable RBIE in PIE
			write_cpu_register(CPU_COMPORT_MASK,0);	// disable COM interrupts
			write_cpu_register(5,61710);				// T0STA prescaler=256
			write_cpu_register32(11,25000);				// TIMER0=26985
			write_cpu_register(7,13);					// no TIMER0 overflow and TIMER0 interrupt disabled
			timer_enabled=1;
			time=read_cpu_register32_verified(CPU_SECONDS_COUNTER);
		}
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
}

enable_com_port_disable_timer()
{
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	if( value_func_pic_version>=700 && value_func_pic_version<=710 )
	{
		write_cpu_register(5,61696);				// T0STA prescaler=0
		write_cpu_register(CPU_COMPORT_MASK,128);	// enable COM interrupts
		write_cpu_register(23+65536,65280+128);	// enable RBIE in PIE
		timer_enabled_func_disable_com_port_enable_timer=0;
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
}

timer_value()
{
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	if(timer_enabled_func_disable_com_port_enable_timer)
	{
		return(read_cpu_register32(11)&65535);
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
	return(-1);
}

timer_overflow()
{
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	if(timer_enabled_func_disable_com_port_enable_timer)
	{
		if( (read_cpu_register(7)&32) )
		{
#IF compile_debug_trace 1 ;
			if(debug_trace_on)
			{
				debug_correction_time++;
			}
#ENDIF ;
			if(time_func_disable_com_port_enable_timer!=read_cpu_register32_verified(CPU_SECONDS_COUNTER))
			{
				disable_com_port_enable_timer();
				return(1);
			}
			disable_com_port_enable_timer();
			return(3);
		}
	}
	return(0);
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
	return(0);
}

// -------------------------------------------------------------------------

read_lcd_status()
{
#IFGREATEROREQUAL system_version 700 ;
	int status;
	if(value_func_pic_version<714)
	{
		write_lcd_command(176);
		write_lcd_command(15);
		write_lcd_command(24);
		cpylcdram(&status, 4 );
		return(status);
	}
	return(123456789);
#ELSE ;
	return(123456789);
#ENDIF ;
}

write_lcd_status(int status)
{
#IFGREATEROREQUAL system_version 700 ;
	if(value_func_pic_version<714)
	{
		write_lcd_command(176);
		write_lcd_command(15);
		write_lcd_command(24);
		cpyramlcd(WRITE_SPRITE, &status, 4 );
	}
#ENDIF ;
}

public correct_16c71_reset()
{
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
	int resets_16c71;
#IFLESSOREQUAL system_version 710 ;
	int ov;
	int resets_17c44;
	if(value_func_pic_version>=700)
	{
		if(value_func_pic_version<750)
		{
			ov=timer_overflow();
			if(read_lcd_status()!=123456789)
			{
				ov=ov|4;
			}
#IF debug_correct_16c71_reset 1 ;
			//beep(10,10);
			if(ov&1)
			{
				beep(10,50);
			}
			if(ov&2)
			{
				beep(10,500);
			}
			if(ov&4)
			{
				beep(10,500);
				delay(25000);
				beep(10,500);
			}
#ENDIF ;
			if( ov & 6 )
			{
#IF compile_debug_trace 1 ;
				debug_trace_function(1000);
				if(debug_trace_on)
				{
					debug_correction_time=0;
				}
#ENDIF ;
				if(ov&2)
				{
					resets_17c44++;
					clrwdt();
				}
#IF compile_debug_trace 1 ;
				debug_trace_function(1001);
#ENDIF ;
				resets_16c71++;
				write_cpu_register(CPU_PORTA,187);
				delay(25000);
				write_cpu_register(CPU_PORTA,191);
				delay(25000);
				//pic_wait_event(4+128+262144,0);			// wait for 0s with lcd disabled (not safe to disable the lcd)

				write_cpu_register(CPU_LCD_ENABLED,0);		// fake it
				pic_wait_event(4+32+262144,50);				// wait for a very shor time
				set_new_lcd();
				
#IF compile_debug_trace 1 ;
				debug_trace_function(1002);
#ENDIF ;
				if(!power_is_off)
				{
					lcd_light_state=-5;
					set_lcd_light_power(lcd_light_power);
				}

				delay(50000);						// wait for a very shor time
				set_lcd_contrast(lcd_contrast-1);				// wait for a very shor time

#IF compile_debug_trace 1 ;
				debug_trace_function(1003);
#ENDIF ;
			}
			else
			{
#IF compile_debug_trace 1 ;
				debug_trace_function(1004);
#ENDIF ;
				if(value_func_pic_version<=708)
				{
					if(!power_is_off)
					{
						lcd_on2();
						set_lcd_contrast(lcd_contrast-1);
					}
				}
#IF compile_debug_trace 1 ;
				debug_trace_function(1005);
#ENDIF ;
			}
		}
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
#IF compile_debug_trace 1 ;
			debug_trace_function(1008);
#ENDIF ;
}

// -------------------------------------------------------------------------

public set_external_keyboard_power(int power)
{
	int baudrate;
#IF system_type rio horizontal ;
	if(power)
	{
		write_cpu_register(CPU_BASIC_FLAGS,65282);
		write_16c71_byte(3);
		delay(50000);							// 250000=1s
		write_cpu_register(CPU_BARCODE_BIT_COUNTER,0);
		write_cpu_register(CPU_BARCODE_BUFFER_GET,0);
		write_cpu_register(CPU_BARCODE_BUFFER_SAVE,0);
		write_cpu_register(CPU_BARCODE_STATUS,0);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,64768);
		write_16c71_byte(4);
	}
#ENDIF ;
#IF system_type ponto ;
	if(power)
	{
		write_cpu_register(CPU_BASIC_FLAGS,65282);
		write_16c71_byte(4);
		delay(50000);							// 250000=1s
		write_cpu_register(CPU_BARCODE_BIT_COUNTER,0);
		write_cpu_register(CPU_BARCODE_BUFFER_GET,0);
		write_cpu_register(CPU_BARCODE_BUFFER_SAVE,0);
		write_cpu_register(CPU_BARCODE_STATUS,0);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,64768);
		write_16c71_byte(3);
	}
#ENDIF ;

#IF system_type vertical ;
#IF laser_type symbol ;
	clrwdt();
	enable_com_port_disable_timer();
	write_cpu_register(CPU_PORTB_VALUE,65280+8);			// Reset em Cima
	write_cpu_register(CPU_PORTE,65280+4);				// laser/IR power ON
	if(power)
	{
		baudrate=baud_func_set_baud_rate2;
		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_PORTE,65280+4);		// laser/IR power ON
		}
		else
		{
			write_cpu_register(3975,65280+2);			// laser/IR power ON
		}
		delay(40000);
		write_cpu_register(CPU_COMPORT_MASK,32);
		set_baud_rate2(9600);
		laser_wake_up();
		laser_set_default_parameters();
		if( laser_write_command(233) == 0 )				// Scan Enable
		{
			return(0);
		}
		if( laser_write_command(228) == 0 )				// Start Decode
		{
			return(0);
		}
		write_cpu_register(CPU_BASIC_FLAGS,65280+2);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,65280-512);

		if(done_func_laser_set_default_parameters)
		{
			write_cpu_register(CPU_COMPORT_MASK,32);
			set_baud_rate2(9600);
			laser_wake_up();
			laser_write_command(229);					// Stop Decode
			laser_write_command(234);					// Scan Disable
			delay(40000);
		}
		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_PORTE,65280-1024);			// laser/IR power OFF
		}
		else
		{
			write_cpu_register(3969,65280+16);
			write_cpu_register(3975,65280-512);				// laser/IR power OFF
		}

		write_cpu_register(CPU_COMPORT_MASK,128);

		disable_com_port_enable_timer();
		clrwdt();
		set_baud_rate2(baudrate);
	}
#ENDIF ;


#IF laser_type intermec psc;
	clrwdt();
	enable_com_port_disable_timer();

	if(power)
	{
		baudrate=baud_func_set_baud_rate2;
		write_cpu_register(CPU_COMPORT_MASK,32);

		if(hardware_is_laser_intermec)
		{
/*
			if(power!=2)
			{	
				write_cpu_register(3978,65280-4096);				// Trigger 0 (prototipo)
			}
*/
			write_cpu_register(5,65280-32768);					// Trigger 0
			set_baud_rate2(19200);

	write_cpu_register(CPU_COMPORT_MASK,32);
	write_cpu_register(CPU_COMBUFFER_GET,0);
	write_cpu_register(CPU_COMBUFFER_SAVE,0);

			if(!laser_set_default_parameters())
			{
				beep(200,1000);
				set_external_keyboard_power(0);
				return(0);
			}
		}
		else
		{
													// PSC
			if(value_func_pic_version<750)
			{
				write_cpu_register(CPU_PORTE,65280+4);			// laser/IR power ON
			}
			else
			{
				write_cpu_register(3975,65280+2);				// laser/IR power ON
			}
			write_cpu_register(CPU_PORTB_VALUE,65280+8);			// Reset em Cima
//			write_cpu_register(CPU_COMPORT_MASK,32);
			set_baud_rate2(9600);
			if(!laser_set_default_parameters())
			{
				beep(200,1000);
				set_external_keyboard_power(0);
				return(0);
			}
		
			if(power!=2)
			{	
				if( !laser_write_command("ZD00",25000,25) )		// Scan Enable
				{
					beep(1000,1000);
					return(0);
				}
			}
		}
		write_cpu_register(CPU_BASIC_FLAGS,65280+2);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,65280-512);

		if(hardware_is_laser_intermec)
		{
			//write_cpu_register(3978,65280+16);			// Trigger 1 (prototipo)
			write_cpu_register(5,65280+128);			// Trigger 1
		}
		else
		{
											// PSC
			//write_cpu_register(CPU_PORTB_VALUE,65280-2048);	// Reset em Baixo
			//write_cpu_register(CPU_PORTB_VALUE,65280+8);		// Reset em Cima
	
			if(value_func_pic_version<750)
			{
				write_cpu_register(CPU_PORTE,65280-1024);		// laser/IR power OFF
			}
			else
			{
				write_cpu_register(3969,65280+16);
				write_cpu_register(3975,65280-512);			// laser/IR power OFF
			}
		}
		
		write_cpu_register(CPU_COMPORT_MASK,128);
		disable_com_port_enable_timer();
		clrwdt();
		set_baud_rate2(baudrate);
	}
#ENDIF ;

#IF laser_type imageteam ;
	int done;
	if(power)
	{
		baudrate=baud_func_set_baud_rate2;
		write_cpu_register(3975,65280+2)	;				// laser/IR power ON
		write_cpu_register(CPU_PORTB_VALUE,65280+8);			// Reset em Cima
		write_cpu_register(3978,256*(255-16));					// RS-232 bit down
		set_baud_rate2(115200);
		write_cpu_register(CPU_COMPORT_MASK,32);			// Accept RS232 input from laser
		write_cpu_register32(CPU_COM_TIMEOUT,ONESECOND*6/10);	// 600ms to power up
		while(laser_read_byte()>=0)
		{
		}

/*
		if(!done)
		{
			done=1;
		}
*/

		laser_write_command("VSUFCR!",ONESECOND,1);				// all CR to all symbologies
		laser_write_command("SCNDLY50!",ONESECOND/10,1);			// show green aiming light 50ms before decoding
		laser_write_command("DECWIN1!",ONESECOND/10,1);			// decode only inside the central area
		if(lcd_light_power)
		{
			laser_write_command("SCNLED1!",ONESECOND/10,1);		// ilumination ON
		}
		else
		{
			laser_write_command("SCNLED0!",ONESECOND/10,1);		// ilumination OFF
		}


//delay(ONESECOND);
//beep(20,100);

		if(!photography)
		{
			if(power!=2)
			{
				laser_write_byte(22);						// Scan Enable
				laser_write_byte('T');						//
				laser_write_byte(13);						//
			}	
			write_cpu_register(CPU_BASIC_FLAGS,65280+2);		// Accept laser input as keypresses
		}

	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,65280-512);		// Stop accepting laser input as keypresses

		//write_cpu_register(CPU_PORTB_VALUE,65280-2048);	// Reset em Baixo
		//write_cpu_register(CPU_PORTB_VALUE,65280+8);		// Reset em Cima

		write_cpu_register(3969,65280+16);				//

		write_cpu_register(3975,65280-512);				// laser/IR power OFF

		write_cpu_register(CPU_COMPORT_MASK,128);		// Don't accept RS232 input from laser

		set_baud_rate2(baudrate);
	}
#ENDIF ;


#IF laser_type eia ;
	clrwdt();
	enable_com_port_disable_timer();
	if(power)
	{
		baudrate=baud_func_set_baud_rate2;
		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_PORTB_VALUE,65280+8);		// Reset em Cima
			write_cpu_register(CPU_PORTE,65280+4);			// laser/IR power ON
			delay(40000);
			write_cpu_register(CPU_COMPORT_MASK,32);
			set_baud_rate2(9600);
			write_cpu_register(CPU_DDRB_VALUE,256*(255-16));
			write_cpu_register(CPU_PORTB_VALUE,256*(255-16));
		}
		else
		{
			write_cpu_register(3975,65280+2);				// laser/IR power ON
			delay(40000);
			write_cpu_register(CPU_COMPORT_MASK,32);
			set_baud_rate2(9600);
			write_cpu_register(3987,256*(255-16));
			write_cpu_register(3978,256*(255-16));
		}
		write_cpu_register(CPU_BASIC_FLAGS,65280+2);
	}
	else
	{
		write_cpu_register(CPU_BASIC_FLAGS,65280-512);

		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_PORTE,65280-1024);		// laser/IR power OFF
			write_cpu_register(CPU_COMPORT_MASK,128);
			write_cpu_register(CPU_PORTB_VALUE,256*255+16);
			write_cpu_register(CPU_DDRB_VALUE,256*255+16);
		}
		else
		{
			write_cpu_register(3969,65280+16);
			write_cpu_register(3975,65280-512);			// laser/IR power OFF
			write_cpu_register(CPU_COMPORT_MASK,128);
			write_cpu_register(3978,256*255+16);
			write_cpu_register(3987,256*255+16);
		}
		disable_com_port_enable_timer();
		clrwdt();
		set_baud_rate2(baudrate);
	}
#ENDIF
#IF tag_type S002 ;
	if(power)
	{
		initialize_rfid();
	}
	else
	{
		terminate_rfid();
	}
#ENDIF;

#ENDIF ;
	return(1);
}

// -------------------------------------------------------------------------

/*
public int clrwdt()
{
	write_cpu_register(7,65344);			// generate clrwdt so the pic does not reset
	set_seconds(get_seconds()-1);
}
*/

public int clrwdt()
{
	int time;
	if(value_func_pic_version<750)
	{
		time=read_cpu_register32_verified(CPU_SECONDS_COUNTER);
		if(read_cpu_register(5)&64)
		{
			write_cpu_register(5,48896);			// generate clrwdt so the pic does not reset
		}
		else
		{
			write_cpu_register(5,48960);			// generate clrwdt so the pic does not reset
		}
		write_cpu_register32_verified(CPU_SECONDS_COUNTER,time);
	}
}

// -------------------------------------------------------------------------

int screen_has_been_updated;
int disable_sensech;

public sensech2()
{
	int keypressed;
	int lastkeypressed;
	int c;
	int multitap_activate;

	correct_16c71_reset();
	if(disable_sensech)
	{
		return(0);
	}

	keypressed=inkey();
	if(keypressed==306)
	{
		if(multitap_alpha==0)
		{
			multitap_alpha=1;
			cursor_height(255);
			really_update_screen();
			beep(200,200);
		}
		keypressed=0;
	}

	if(keypressed)
	{
		if(keypressed!=lastkeypressed)
		{
			key_repeat_timer=0;
			key_repeat_times=0;
		}
		lastkeypressed=keypressed;
		if(keypressed<256)					// Do not buffer the laser scanner
		{
			keyboard_save_in_buffer(keypressed,0);
		}
		if(key_repeat_timer)
		{
			if(key_repeat_timer>0)
			{
				key_repeat_timer--;
				if(!key_repeat_timer)
				{
					key_repeat_times++;		// go faster after the first repeat
				}
			}
			else
			{
				key_repeat_timer=key_repeat_timer_down_value;
			}
		}
		if(key_repeat_timer)
		{
			keypressed=0;
		}
	}
	else
	{
#IFNOT system_type ponto ;
		if(internal_shift_key)
		{
			disable_shift_key();
		}
#ENDIF ;
		key_repeat_times=0;				// mark that next repeat is the first
		if( key_repeat_timer>0)
		{
			key_repeat_timer=key_repeat_timer_up_value;
		}
		if(key_repeat_timer<0)
		{
			key_repeat_timer++;
		}
	}
	if(keypressed)
	{
		if(keyboard_save_in_buffer(translate_scancode(keypressed),keypressed))
		{
			keyboard_beep();
			set_key_repeat_timer();
		}
	}
	c=keyboard_read_from_buffer(0);
	if(c)
	{
		screen_has_been_updated=0;
	}
	return(c);
}

public kbhit()
{
	if(sensech())
	{
		if(lastkeypressed_func_sensech2<256)
		{
			return(2);
		}
		return(1);
	}
	return(0);
}

public sensech()
{
	push_variable(sensech2());
	if(keypressed_func_sensech2||internal_shift_key)
	{
		power_off_countdown_restart();
	}
	return(pop_variable());
}

// --------------------- Keyboard - insert keys ----------------------------

public setch(int c)
{
	keyboard_save_in_buffer(c,0);
}

public ungetch()
{
	if(ptr_read_func_keyboard_save_in_buffer)
	{
		ptr_read_func_keyboard_save_in_buffer--;
	}
}

// --------------------------------------------------------------------------

int memcpy_if_memcmp(char *dpointer,char *spointer,int size,int e)
{
	int size2;
	int changed;

	changed=0;

	while(size)
	{
		size2=size;
		if( (dpointer/32768) != ((dpointer+size2)/32768) )
		{
			size2=32768-(dpointer&32767);
		}

		if(memcmp(dpointer,spointer,size2))
		{
			if(e)
			{
				cursor(0);
				print_string("Error in eeprom #");
				print_number( ((dpointer/32768)&7) + 1 );
#IFNOT software_type		RADIOBASE ;
				getch();
#ENDIF ;
			}
			write_cpu_register(CPU_EEPROM_LOCK,123);
			memcpy(dpointer,spointer,size2);
			write_cpu_register(CPU_EEPROM_LOCK,0);
			changed++;
		}
		size-=size2;
		dpointer+=size2;
		spointer+=size2;
	}

	return(changed);
}

#IF compile_debug_trace 1 ;
debug_trace_function(int v)
{
	if(debug_trace_on)
	{
		debug_trace_value=v;
	}
}
#ENDIF ;

write_16c71_byte(int value)
{
	char *ptr;
	char c;
	int a,b;

	if(value_func_pic_version!=712)
	{
		pic_write_16c71_byte(value);
		return;
	}	

	a=read_cpu_register32(CPU_STACK);			// save stack pointer

	c=*ptr;
	ptr=0;
	*ptr=85;							// 90=beep 85=write_cpu_register

	push_variable(78);						// 4e should be RPC contents
	push_variable(80);						// 50 is address of RPC

	write_cpu_register(CPU_REGDEL2,0);			// prevent hanging on delay call
	write_cpu_register(CPU_REGDEL3,0);			//

	write_cpu_register(192,0);					// new value of RPC will make PC appear here
	write_cpu_register(193,0);					//
	write_cpu_register(194,0);					//
	write_cpu_register(195,0);					//
	write_cpu_register(196,0);					//
	write_cpu_register(197,0);					//

// 32 bits version
/*
	write_cpu_register32(186,0);
	write_cpu_register32(190,0);
	write_cpu_register32(194,0);
	write_cpu_register32(198,0);
	write_cpu_register32(202,0);
*/


	pic_write_16c71_byte(value);

ASM breakpoint ;
ASM breakpoint ;
ASM breakpoint ;
ASM breakpoint ;
ASM breakpoint ;

	*ptr=c;

write_16c71_byte_l1:

	b=read_cpu_register32(CPU_STACK);			// read stack pointer

	if(b==a)							// make sure it is the same
	{
		return;
	}

	pop_variable();

	goto write_16c71_byte_l1;
	
}

// -------------------------------------------------------------------------

#IF system_type vertical ;

public lcd_off()
{
	if(value_func_pic_version<714)
	{
		write_lcd_command(174);		// display off
		write_lcd_command(165);		// all pixels clear
	}
	else
	{
		write_lcd_command(169);
	}
}

public lcd_on2()
{
	if(value_func_pic_version<714)
	{
		write_lcd_command(196);		//
		write_lcd_command(160);		//
		write_lcd_command(169);		//
		write_lcd_command(170);		// duty+1
		write_lcd_command(37);		// power
		delay(2500);
		write_lcd_command(237);		// power2
	}
	lcd_on();
}

public lcd_on()
{
	if(value_func_pic_version<714)
	{
		write_lcd_command(164);		// disable all pixels clear
		write_lcd_command(175);		// display on
	}
	else
	{

		write_lcd_command(225);
/*
		write_lcd_command(168);
		write_lcd_command(171);
		write_lcd_command(47);
		write_lcd_command(175);
		write_lcd_command(103);
		write_lcd_command(37);
		write_lcd_command(129);
		write_lcd_command(31);
		write_lcd_command(72);
		write_lcd_command(64);
		write_lcd_command(68);
		write_lcd_command(8);
		write_lcd_command(161);
*/
	}
	set_new_lcd();
}

int last_allow_on;
public power_off()
{
	int was;
	int voltage;
	int voltage_allowed_on;
	int x;
	int can_exit;
	int n;
	int status_rfid_before_power_down;

#IF gps_type fastrax ;
	set_gps_power(-1);
#ENDIF ;

#IF tag_type TagIt novatronica Calypso Rfid125 ;
	if(status_rfid==1)
	{
		status_rfid_before_power_down=1;
		terminate_rfid();
	}
	else
	{
		status_rfid_before_power_down=0;	
	}	
#ENDIF;


	call_function(function_before_power_off);

	power_is_off=1;
	was=1;
	
	if( voltage_func_power_off_countdown < critical_operation_voltage_limit )
	{
#IF battery_management_version 1 ;
		voltage_allowed_on = critical_operation_voltage_limit + 30;
		if( battery_charge )
		{
			battery_charge=1;
		}
#ELSE ;
		voltage_allowed_on = critical_operation_voltage_limit + 600;
		battery_charge=0;
#ENDIF ;
	}
	else
	{
		voltage_allowed_on = critical_operation_voltage_limit;
	}
	power_off_beep
	push_variable( read_cpu_register(CPU_BASIC_FLAGS) );
	if( read_cpu_register(CPU_BASIC_FLAGS) & 2 )
	{
		set_external_keyboard_power(0);
	}
	set_lcd_light_power(-1);

#IFLESS system_version 700 ;
	write_16c71_byte(13);							// set_ir_power(0)
#ENDIF ;

	for( x=CPU_SCREENLINE1; x<=CPU_SCREENLINE8; x+=4)
	{
		push_variable(read_cpu_register32(x));
	}
	inside_os_menu+=2;

	can_exit=0;
	do
	{
		if(value_func_pic_version>=790)
		{
			radio_configuration(257);				// battery may go down, move it out of the way (power 0, channel 64, band 1)
		}

		last_allow_on=-1;
		do
		{

			if(voltage_func_battery_voltage<voltage_allowed_on)
			{
				battery_voltage();					// read battery
			}
			voltage=voltage_func_battery_voltage;

			key_repeat_times++;

			do
			{
				if(update_battery_check_discharge())
				{
					last_allow_on=-1;					// force a screen redraw
				}

				n=allow_on();
				if(last_allow_on!=n)
				{
					last_allow_on=n;
					power_off_refresh_screen(last_allow_on,1);	// and show status
				}

				n=sensech2();
				flush_keyboard_buffer();

				if(can_exit)
				{
					if(last_allow_on)
					{
						if( n=='.' )
						{
							if(internal_shift_key)
							{
								goto UnlockKeyboard;
							}
						}
						if(hardware2&8)
						{
							goto UnlockKeyboard;
						}
					}
				}
			}
			while(inkey()||inkey()||inkey());
			can_exit=1;
		}
		while( ( wait_event(5,1) & 1 ) );					// wait for keypress or 1s

		battery_voltage();
		update_battery(0);
		do
		{

			if(charging_func_update_battery)
			{
				lcd_on();
				n=0;
				do
				{
					if(battery_charge<255)
					{
						power_off_refresh_screen(last_allow_on,0);
					}
					x=wait_event(5,0);
					if(x&1)
					{
						break;
					}
#IFGREATEROREQUAL system_version 600 ;
					power_off_refresh_screen(last_allow_on,1);
#ENDIF ;
					x=wait_event(5,0);
					if(x&1)
					{
						break;
					}
					battery_voltage();
					update_battery(2);
					if(!charging_func_update_battery)
					{
						break;
					}
					n+=2;
				}
				while(n<171);
			}
			else
			{
				lcd_off();
				x=wait_event(5,171);				// 171s
			}

			voltage=battery_voltage();

			if(x&4)
			{
				update_battery(171);				// 171s
			}
			else
			{
				break;
			}

#IF compile_show_hours 1 ;
			if(allow_on())
			{
				lcd_on();
				goto UnlockKeyboard;
			}
#ENDIF;

#IF compile_alarm 1 ;
			if(time_func_set_alarm)
			{
				if(get_seconds()>time_func_set_alarm)
				{
					if(vector_func_set_alarm)
					{
						lcd_on();
						vector_func_set_alarm();
						lcd_off();
					}
					if(repeat_func_set_alarm)
					{
						time_func_set_alarm+=repeat_func_set_alarm;
					}
					else
					{
						time_func_set_alarm=0;
					}
				}
			}
#ENDIF ;
		}
		while( 1 );
		lcd_on();
	}
	while(1);

UnlockKeyboard:
	power_off_refresh_screen(1,1);					// and show status
	inside_os_menu-=2;
	set_display(display_address_func_set_display);
	for( x=CPU_SCREENLINE8; x>=CPU_SCREENLINE1; x-=4)
	{
		write_cpu_register32(x,pop_variable());
	}
	#IF compile_os_menu 1;
	battery_bar(0);
	#ENDIF;
	update_screen();
#IFLESS system_version 700 ;
	if( n_func_set_ir_power )
	{
		set_ir_power(1);
	}
#ENDIF ;
	if( pop_variable() & 2 )
	{
		set_external_keyboard_power(1);
	}
	power_is_off=0;
	update_screen();
//	if( time_to_reset && ( get_seconds() > ( menu_exit_countdown_start + time_to_reset ) ) )
	if( time_to_reset && ( read_cpu_register32_verified(CPU_SECONDS_COUNTER) > ( menu_exit_countdown_start + time_to_reset ) ) )
	{
		reset(0);
	}
	power_on_beep
	while(sensech())
	{
		getch2();
	}
	power_off_countdown_restart();
	call_function(function_before_power_up);

#IF gps_type fastrax ;
	if(gps_power)
	{
		set_gps_power(1);
	}
#ENDIF ;

#IF tag_type TagIt novatronica Calypso Rfid125 ;
	if(status_rfid_before_power_down==1)
	{
		status_rfid_before_power_down=0;
		initialize_rfid();
	}
#ENDIF;

}
#ENDIF ;

public allow_on()
{
#IF battery_management_version 1 ;
	if(!battery_charge)
	{
		if( battery_voltage_index <= battery_voltage_2_bar_limit )
		{
			battery_charge++;
		}
	}
	if( voltage_func_power_off >= voltage_allowed_on_func_power_off )
	{
		return(1);
	}
	else
	{
		return(0);
	}
#ELSE ;
	if( ( voltage_func_power_off >= voltage_allowed_on_func_power_off) && (battery_charge>=3) )
	{
		return(1);
	}
	else
	{
		if( battery_charge>63 )
		{
			battery_charge=63;
		}
		return(0);
	}
#ENDIF ;
}

public power_off_refresh_screen(int allow, int showbat)
{
#IF debug 1 ;
	battery_charge=battery_charge|1;
#ENDIF ;
	init_lcd(0);
	set_new_lcd();
	set_lcd_contrast(lcd_contrast-1);

	write_cpu_register32(CPU_SCREENLINE1,blank_screen_line);
	write_cpu_register32(CPU_SCREENLINE2,blank_screen_line);
	write_cpu_register32(CPU_SCREENLINE3,blank_screen_line);
	write_cpu_register32(CPU_SCREENLINE4,blank_screen_line);
	if(value_func_pic_version>=715)
	{
		write_cpu_register32(CPU_SCREENLINE5,auxstring3);
	}
	else
	{
		write_cpu_register32(CPU_SCREENLINE5,auxstring3+3);
	}
	write_cpu_register32(CPU_SCREENLINE6,blank_screen_line);
/*
itoa(voltage_func_battery_voltage,auxstring0,10);
strcat(auxstring0,"mV ");
itoa(battery_voltage_peak_func_update_battery,auxstring0+strlen(auxstring0),10);
strcat(auxstring0,"mV ");
itoa(battery_voltage_dip_func_update_battery,auxstring0+strlen(auxstring0),10);
strcat(auxstring0,"mV ");
*/
	write_cpu_register32(CPU_SCREENLINE7,auxstring0);
	write_cpu_register32(CPU_SCREENLINE8,blank_screen_line);

	if(allow)
	{
		if(!(hardware2&8))
		{
			write_cpu_register32(CPU_SCREENLINE8,auxstring1);
		}
	}
	else
	{
		/*
		memset(auxstring2,'*',20);
		itoa(voltage_func_battery_voltage,auxstring2,10);
		itoa(voltage_allowed_on_func_power_off,auxstring2+6,10);
		itoa(battery_charge,auxstring2+12,10);
		*/
		write_cpu_register32(CPU_SCREENLINE8,auxstring2);
	}
#IFNOT software_type	RADIOBASE;
#IF compile_os_menu 1 ;
#IFGREATEROREQUAL system_version 600 ;
	if(value_func_pic_version>=715)
	{
		write_cpu_register(CPU_LCD_WIDTH,128);
	}
	else
	{
		write_cpu_register(CPU_LCD_WIDTH,100);
	}
	update_screen();
	if(showbat)
	{
		battery_bar(2);
	}
	else
	{
		battery_bar(-100);
	}
#ENDIF ;
#ENDIF;
#ENDIF;
	update_screen();
#IFGREATEROREQUAL system_version 700 ;
	if(value_func_pic_version>=715)
	{
		display_rom_graphics(24+256);
	}
	else
	{
		display_rom_graphics(10+256);
	}
#ENDIF ;
}

// -------------------------------------------------------------------------

//					;     - EVENT CHECKING FLAGS -
//					;  128    64    32        16    8    4     2    1
//					;    7     6     5         4    3    2     1    0
//					; DLCD RADIO TICKS       TAG  COM TIMR  EXTK INTK
//					; xxxx xxxxx xxxxx xxxxxxxxx xxxx xxxx xxxxx xxxx
//					; xxxx xxxxx COMSB NOREENLCD DIRC NOSL RDLCD xxxx
//					; xxxx xxxxx xxxxx xxxxxxxxx xxxx xxxx xxxxx xxxx
//
wait_event(int a,int b)
{
	int n;
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	int a2;
#IF compile_debug_trace 1 ;
	debug_trace_function(2000);
#ENDIF ;
	if(value_func_pic_version<=710)
	{
#IF compile_debug_trace 1 ;
		debug_trace_function(2001);
#ENDIF ;
		a2= ( a & (16777215 -128 -131072) ) | 4 | 32 | 262144 ; 	// -DLCD -RDLCD +TIMR +TICKS +NOSL

// beep(100,100);

		correct_16c71_reset();
#IF compile_debug_trace 1 ;
		debug_trace_function(2002);
#ENDIF ;
		n=pic_wait_event( a2,130000 );
		set_new_lcd();
#IF compile_debug_trace 1 ;
		debug_trace_function(2003);
#ENDIF ;
		if(n&a&1)
		{
#IF compile_debug_trace 1 ;
			debug_trace_function(2004);
#ENDIF ;
			sensech2();

// beep(100,100);

			correct_16c71_reset();
#IF compile_debug_trace 1 ;
			debug_trace_function(2008);
#ENDIF ;
			return(n);
		}
		else
		{
#IF compile_debug_trace 1 ;
			debug_trace_function(2006);
#ENDIF ;

// beep(100,100);

			correct_16c71_reset();
#IF compile_debug_trace 1 ;
			debug_trace_function(2007);
#ENDIF ;
		}
		if( n & 4 )									// timer event
		{
			if( a & 4 )								// client wanted a timer event
			{
				if( ( a & 131072 ) == 0 )					// DLCD was not intended
				{
					if( b<=1 )
					{
#IF compile_debug_trace 1 ;
			debug_trace_function(2009);
#ENDIF ;
						return(n);
					}
					b--;
				}
			}
		}
		else
		{
#IF compile_debug_trace 1 ;
			debug_trace_function(2010);
#ENDIF ;
			return(n);
		}
	}

//	#ELSE ;
//	correct_16c71_reset();

#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;


#IF compile_debug_trace 1 ;
	debug_trace_function(2011);
#ENDIF ;

#IF debug_correct_16c71_reset 1 ;
	beep(30,200);
#ENDIF ;

	if(value_func_pic_version>=750)
	{
		write_cpu_register(4082,64768);
		write_cpu_register(4080,64512);
	}

	n=pic_wait_event(a,b);
	set_new_lcd();

#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
#IFLESSOREQUAL system_version 710 ;
	if(!(a&262144))
	{
		if(timer_enabled_func_disable_com_port_enable_timer)
		{			
			disable_com_port_enable_timer();
		}
	}
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;


#IF compile_debug_trace 1 ;
	debug_trace_function(2012);
#ENDIF ;

	return(n);

}

// -------------------------------------------------------------------------

#IF compile_debug_lines 1 ;

show_debug_line_text(char *txt)
{
	debug_lines=1;
	set_display(display_address_func_set_display);
	write_cpu_register32(CPU_SCREENLINE1+title_lines+debug_lines,txt);
	update_screen();
}

show_debug_line_number(int n)
{
	char txt[30];
	itoa(n,txt,10);
	debug_lines=1;
	set_display(display_address_func_set_display);
	write_cpu_register32(CPU_SCREENLINE1+title_lines,txt);
	update_screen();
}

show_debug_line_number_text(int n,char *txt)
{
	int n2;
	show_debug_line_number(n);
	strcat(txt_func_show_debug_line_number,txt);
	update_screen();
	if(n!=n2)
	{
		n=n2;
		beep(100,5000);
		delay(500000);
	}
}

show_debug_line_number_number_text(int n,int nn,char *txt)
{
	int n2,nn2;
	show_debug_line_number(n);
	strcat(txt_func_show_debug_line_number,",");
	itoa(nn,txt_func_show_debug_line_number+strlen(txt_func_show_debug_line_number),10);
	strcat(txt_func_show_debug_line_number,",");
	strcat(txt_func_show_debug_line_number,txt);
	really_update_screen();
//	if((n!=n2) ||(nn!=nn2) )
	if((n!=n2) )
	{
		n2=n;
		nn2=nn;
		beep(150,5000);
	}
}

#ENDIF ;

// -------------------------------------------------------------------------

check_shift_esc()
{
	if(sensech()==27)
	{
		getch();
		return(internal_shift_key);
	}
	return(0);
}

// -------------------------------------------------------------------------

// lixo #define write_com2_block pic_write_com2_block

/*
write_com2_block(char *buffer,int size)
{
	if(value_func_pic_version>790)
	{
		pic_write_com2_block(buffer,size);
	}
	else
	{
		while(size>=16)
		{
			write_com2_block16(buffer);
			buffer+=16;
			size-=16;
		}
		while(size)
		{
			write_com2_byte(*buffer);
			buffer++;
			size--;
		}
	}
}

write_com2_block16(char *buffer)
{
	write_com2_byte(*buffer);
	write_com2_byte(*buffer+1);
	write_com2_byte(*buffer+2);
	write_com2_byte(*buffer+3);
	write_com2_byte(*buffer+4);
	write_com2_byte(*buffer+5);
	write_com2_byte(*buffer+6);
	write_com2_byte(*buffer+7);
	write_com2_byte(*buffer+8);
	write_com2_byte(*buffer+9);
	write_com2_byte(*buffer+10);
	write_com2_byte(*buffer+11);
	write_com2_byte(*buffer+12);
	write_com2_byte(*buffer+13);
	write_com2_byte(*buffer+14);
	write_com2_byte(*buffer+15);
}

*/

#IFNOT laser_type none ;

enable_laser_reading()
{
	
}

disable_laser_reading()
{
	
}

#ENDIF ;

// ------------------------------------ GPS  Novatronica -------------------------------------------------------------------

#IF tag_type novatronica ;

int module_gps;
int module_rfid;
char RfidSize;


rfid_on()
{
	write_cpu_register(3983,65280+16);					// LATG4  TagIt ON versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3992,(256*(255-16)));				// TRISG4 TagIt ON versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3994,(256*(255-8)));					// TRISJ3
	
}

rfid_off()
{
	write_cpu_register(CPU_COMPORT_MASK,128);
	write_cpu_register(3983,(256*(255-16)));				// LATG4 TagIt OFF versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3994,65280+8);					// TRISJ3
}


public initialize_gps()
{
	module_gps=1;
	int ct,x;
	
	write_cpu_register(3987,256*255+8);					// PORTB 3 must be input
	write_cpu_register32(CPU_COM_TIMEOUT,50000);
	set_rfid_baud_rate(9600);
	// On
	rfid_on();
	delay(50000);
	
	write_rfid_byte('G');
	write_rfid_byte('P');
	write_rfid_byte('S');
	write_rfid_byte(',');
	write_rfid_byte('1');
	
	write_rfid_byte(10);
	write_rfid_byte(13);

	x=read_com2_byte();
	ct=0;
	while(x!=-1 )									// 01bh
	{
		ct++;
		x=read_com2_byte();
	}
	return(ct);
}

public read_gps_buffer(char *gpsdata)
{
	int x,ct;
	write_rfid_byte('G');
	write_rfid_byte('P');
	write_rfid_byte('S');
	write_rfid_byte(',');
	write_rfid_byte('2');
	
	write_rfid_byte(10);
	write_rfid_byte(13);

	write_cpu_register32(CPU_COM_TIMEOUT,ONESECOND);

	x=read_com2_byte();
	ct=0;
	while(x!=-1 )									// 01bh
	{
		*(gpsdata+(ct&63))=x;
		ct++;
		x=read_com2_byte();
	}
	*(gpsdata+(ct&63))=0;
}

public terminate_gps()
{
	write_rfid_byte('G');
	write_rfid_byte('P');
	write_rfid_byte('S');
	write_rfid_byte(',');
	write_rfid_byte('0');
	
	write_rfid_byte(10);
	write_rfid_byte(13);

	module_gps=0;
	if(module_rfid==0)
	{
		rfid_off();
	}
}	


// ------------------------------------ RFID Novatronica  -------------------------------------------------------------------

public write_rfid_command(char cmd,char block_number,char *data,char len)
{

}

public initialize_rfid()
{
int x,ct;
	module_rfid=1;
	status_rfid=1;
	write_cpu_register(3987,256*255+8);					// PORTB 3 must be input
	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	set_rfid_baud_rate(9600);
	// On
	rfid_on();
	delay(50000);
	
	write_rfid_byte('R');
	write_rfid_byte('F');
	write_rfid_byte('I');
	write_rfid_byte('D');
	write_rfid_byte(',');
	write_rfid_byte('1');
	
	write_rfid_byte(10);
	write_rfid_byte(13);

	write_cpu_register32(CPU_COM_TIMEOUT,150000);

	x=read_com2_byte();
	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	ct=0;
	while(x!=-1 )									// 01bh
	{
		ct++;
		x=read_com2_byte();
	}
	return(ct);

}

public terminate_rfid()
{
	status_rfid=0;
	write_rfid_byte('R');
	write_rfid_byte('F');
	write_rfid_byte('I');
	write_rfid_byte('D');
	write_rfid_byte(',');
	write_rfid_byte('0');
	
	write_rfid_byte(10);
	write_rfid_byte(13);

	module_rfid=0;
	if(module_gps==0)
	{
		rfid_off();
	}
}	

#ENDIF ;




// ------------------------------------ Calypso  -------------------------------------------------------------------

#IF tag_type Calypso ;

extern char time_string[10];
extern char date_string[30];

char calypso_answer[256];

public rfid_on()
{
	write_cpu_register(3975,65280+2);			// laser/IR power ON
	write_cpu_register(CPU_COMPORT_MASK,32);
	write_cpu_register32(CPU_COM_TIMEOUT,ONESECOND);
	set_baud_rate(9600);
}

public rfid_off()
{
	write_cpu_register(3975,65280-2*256);			// laser/IR power OFF
	write_cpu_register(CPU_COMPORT_MASK,0);		
}




public disable_boot_demo_mode()
{
	int flag,len;
	if(flag==0)
	{	
		char data1[]={83,2,129};
		delay(ONESECOND*2);
		write_rfid_block(data1,3,&len);
		delay(ONESECOND/2);
		flag=1;
	}	
}



int Calypso_Sleep_mode;
public initialize_rfid()
{
	int n;
	status_rfid=1;
	rfid_on();
	disable_boot_demo_mode();
	n=0;
	do
	{
		delay(ONESECOND/10);
		n++;
	
	}while(n<10);
	return(1);
}	

public terminate_rfid()
{
	status_rfid=0;
	rfid_off();
}	

rfid_send_byte(int byte,int reset)
{
	int xor;
	xor=xor ^ byte;
	laser_write_byte(byte);
	if(reset)
	{
		laser_write_byte(xor);
		xor=0;
	}
}

public write_rfid_data(char *data,int len)
{
int seq;
int ct;
	ct=0;
	rfid_send_byte(64,0);		// Node Address ( NAD=0, DAD=4h)
	rfid_send_byte(seq*64,0);		// Control Byte ( I-Block) Sequence bit 0 ????
	rfid_send_byte(len,0);
	while(len>1)
	{
		rfid_send_byte(*(data+ct),0);	
		len--;
		ct++;
	}
	if(len==1)
	{
		rfid_send_byte(*(data+ct),1);			
	}
	seq=1-seq;
}

public read_rfid_response(int *len)
{
	int NAD,PCB,XOR,ct,n;
	n=0;
	write_cpu_register32(CPU_COM_TIMEOUT,ONESECOND/10);
	NAD=laser_read_byte();
	if(NAD==-1)
	{
		return(-1);
	}

	if(NAD==4)
	{
		PCB=laser_read_byte();
		*len=laser_read_byte();
		if(*len)
		{	
			ct=0;
			while(ct<*len)
			{
				*(calypso_answer+ct)=laser_read_byte();
				ct++;
			}
			laser_read_byte();
			if((PCB & 128)==128 && (PCB&64)==0 )
			{
				return(-2);
			}
			return(1);
		}
	}
	return(-3);
}


public write_rfid_block(char *data_to_send,int len1,int *len2)
{
	memset(calypso_answer,20,0);		
	write_cpu_register32(CPU_COM_TIMEOUT,1);
	do
	{
	}while(laser_read_byte()>=0);
	write_cpu_register32(CPU_COM_TIMEOUT,ONESECOND);
	write_rfid_data(data_to_send,len1);
	return(read_rfid_response(len2));
}

public read_rfid_serial_always(char  *data)
{
	char data1[]={208,17,0,1};
	int answer;
	int len;
	int *serial_number;
	char *serial;

	if(initialize_rfid()==0)
	{
		return(0);
	}

#IF compile_show_hours 1 ;
	cls();
#ENDIF;

int cttt;
	do
	{	
		delay(30000);
		if(cttt>3)
		{
			cttt=0;
			answer=write_rfid_block(data1,4,&len);
		}
		else
		{
			cttt++;
			answer=0;	
		}
		if(answer==-1)
		{
			terminate_rfid();
			initialize_rfid();	
		}
#IF compile_alarm 1 ;
		if(check_alarm2!=0)
		{
			if(check_alarm2())
			{
					cls();
			}	
		}
#ENDIF ;

#IF compile_show_hours 1 ;
		cursor(0);
		cursor_width(0);
		get_time();
		strcat(time_string," ");
		strcat(date_string," ");
		
		if(time_string[0]=='0')
		{
			time_string[0]=' ';
		}
		if(date_string[0]=='0')
		{
			date_string[0]=' ';
		}

		cursor(print_width*4+5);
		print_large_string(time_string);			// hora

		cursor(print_width*5+10);
		print_string(date_string+11);			// dia da semana

		cursor(print_width*6+7);
		print_string(date_string);				// data

		really_update_screen();
		power_off_countdown();		
#ELSE ;
		delay(25000);
#ENDIF ;

		if(inkey()==ESCAPEKEY)
		{
			sensech();
			break;
		}

	}while(		(calypso_answer[0]!=0 || answer<=0));
		
	if(answer>0)
	{
		serial[0]=calypso_answer[5];
		serial[1]=calypso_answer[4];
		serial[2]=calypso_answer[3];
		serial[3]=calypso_answer[2];
		if(calypso_answer[0]==0)
		{
		
			int high,*low;
			char auxstring[25];
			memset(auxstring,0,25);
			
			low =serial;
			high=0;
			ASM push_parameter 0 ;
			ASM push_parameter auxstring_func_read_rfid_serial_always ;
			push_variable(high);
			push_variable(*low);
			ASM define_char ;
			pop_variable();	

			strcpy(data,"0000000000");
			strcpy(data+10-strlen(auxstring),auxstring);

			return(1);
		}
	}
	terminate_rfid();
	
	return(0);
}



public read_rfid_serial_ISO_14443B(char  *serial)
{
	char data1[]={208,17,0,1};
	int answer;
	int len;

	while(inkey())
	{
	}

	if(initialize_rfid()==0)
	{
		delay(ONESECOND);	
	}

	do
	{	
		answer=write_rfid_block(data1,4,&len);
	}while( (calypso_answer[0]!=0 || answer<=0)  && inkey()==0);	 
	terminate_rfid();
		
	if(answer>0)
	{	
		serial[0]=calypso_answer[5];
		serial[1]=calypso_answer[4];
		serial[2]=calypso_answer[3];
		serial[3]=calypso_answer[2];
		if(calypso_answer[0]==0)
		{
			return(1);
		}
	}
	return(0);
}




#ENDIF;

// ------------------------------------ TagIt  -------------------------------------------------------------------

#IF tag_type TagIt ;
char RfidSize;

public initialize_rfid()
{
	int n;
	status_rfid=1;
	write_cpu_register(3987,256*255+8);					// PORTB 3 must be input
	write_cpu_register32(CPU_COM_TIMEOUT,25000);
	set_rfid_baud_rate(19200);

	rfid_on();
	delay(125000);
}	

public terminate_rfid()
{
	status_rfid=0;
	rfid_off();
	write_cpu_register(CPU_COMPORT_MASK,128);
}	



public read_rfid_result2(char *data)
{
	int header,pos;
	int n;
	int len;
	int key;
	char *data2;
	data2=data;

	write_cpu_register32(CPU_COM_TIMEOUT,100000);
	header=read_com2_byte();

	write_cpu_register32(CPU_COM_TIMEOUT,10000);				// 10000
	if(header==27)									// 01bh
	{
		len=read_com2_byte();						// Data Type(Mifare) OR Size
		read_com2_byte();							// Data Type		OR 15693 Nao se usa ????

		while(1)
		{
			key=read_com2_byte();
			if(key==-1)
			{
				break;
			}
			*data=key;
			data++;
		}
		if(memcmp(data2,"ail!",4))							// Fail! but 1st char was skipped
		{
			return(1);
		}
	}
	return(0);
}

extern char time_string[10];
extern char date_string[30];


public read_rfid_serial_always(char *data)
{
	char auxstring[30];
	int desencrava;
	initialize_rfid();

#IF compile_show_hours 1 ;
	cls();
#ENDIF;

	do
	{
			
#IF compile_alarm 1 ;
			if(check_alarm2!=0)
			{
				if(check_alarm2())
				{	
					cls();
				}	
			}
#ENDIF ;
		if(tagMifare<=1)
		{
			tagMifare=1-tagMifare;
			delay(80000);
		}
		
#IF compile_show_hours 1 ;
		cursor(0);
		cursor_width(0);
		get_time();
		if(time_string[0]=='0')
		{
			time_string[0]=' ';
		}
		if(date_string[0]=='0')
		{
			date_string[0]=' ';
		}

		cursor(print_width*4+5);
		print_large_string(time_string);			// hora

		cursor(print_width*5+10);
		print_string(date_string+11);			// dia da semana

		cursor(print_width*6+7);
		print_string(date_string);				// data

		really_update_screen();
		
		power_off_countdown();		
#ELSE ;
		delay(25000);
#ENDIF ;
		delay(50000);
		empty_com2_buffer();
			
		if(tagMifare &1)
		{	
			write_rfid_command('A',1,0,0);
		}
		else
		{
			write_rfid_command('I',1,0,0);	
		}

		if(read_rfid_result2(data))
		{
#IFNOT compile_show_hours 1 ;
			terminate_rfid();
#ENDIF;			
			tagMifare=tagMifare | 2;
			int *high,*low;
			low =data;
			high=data+4;
			ASM push_parameter 0 ;
			ASM push_parameter auxstring_func_read_rfid_serial_always ;
			push_variable(*high);
			push_variable(*low);
			ASM define_char ;
			pop_variable();	

			if(tagMifare &1)
			{
				strcpy(data,"0000000000");
				strcpy(data+10-strlen(auxstring),auxstring);
			}
			else
			{
				strcpy(data,"00000000000000000000");
				strcpy(data+20-strlen(auxstring),auxstring);
			}
			beep(100,100);
			return(1);
		}
	}while(inkey()!=ESCAPEKEY);
	terminate_rfid();
	return(0);
}


public read_rfid_result(char *data,int timeout)
{
	int header,pos;
	int n;
	int len;
	char *data2;
	data2=data;
	pos=read_cpu_register(CPU_COMBUFFER_GET) ;

	if( wait_event(9+4+4*65536,1)&1 )
	{
		return(0);
	}

	write_cpu_register32(CPU_COM_TIMEOUT,timeout);
	header=read_com2_byte();
	write_cpu_register32(CPU_COM_TIMEOUT,10000);				// 10000
	if(header==27)									// 01bh
	{
		len=read_com2_byte();
		if(len>0)
		{
			len--;
			read_com2_byte();							// skip first byte, it is not data
		}
		while(len>0)
		{
			*data=read_com2_byte();
			data++;
			len--;
		}
		if(memcmp(data2,"ail!",4))							// Fail! but 1st char was skipped
		{
			return(1);
		}
	}
	write_cpu_register(CPU_COMBUFFER_GET,pos);
	return(0);
}

/*
public read_rfid_result_ISO14443(char *data,int timeout)
{
	int header,pos;
	int n;
	int len;
	char *data2;
	data2=data;
	pos=read_cpu_register(CPU_COMBUFFER_GET) ;

	if( wait_event(9+4+4*65536,1)&1 )
	{
		return(0);
	}

	write_cpu_register32(CPU_COM_TIMEOUT,timeout);
	header=read_com2_byte();
	write_cpu_register32(CPU_COM_TIMEOUT,10000);				// 10000
	if(header==27)									// 01bh
	{
		len=read_com2_byte();						// Data Type
		if(len!=5)								// Erro
		{
			read_com2_byte();						// Data Type		
		}
		while(len>0)
		{
			*data=read_com2_byte();
			if(*data==-1)
			{
				break;
			}
			data++;
			len--;
		}
		if(memcmp(data2,"Fail!",5))							// Fail! but 1st char was skipped
		{
			return(1);
		}
	}
	write_cpu_register(CPU_COMBUFFER_GET,pos);
	return(0);
}
*/

public write_rfid_command(char cmd,char block_number,char *data,char len)
{
	int n;

	empty_com2_buffer();
	
	write_rfid_byte(27);
	write_rfid_byte(cmd);
	if(block_number)
	{
		write_rfid_byte(block_number);
		while(len)
		{
			write_rfid_byte(*data);
			data++;
			len--;
		}
	}
}

public write_rfid_block(char block_number,char *data)
{
	initialize_rfid();
	write_rfid_command('W',block_number,data,4);
	if(read_rfid_result(temp_string,100000))
	{
		terminate_rfid();
		return(1);
	}
	terminate_rfid();
	return(0);
}

public read_rfid_block(char block_number,char *data)
{
	initialize_rfid();
	write_rfid_command('R',block_number,0,0);
	if(read_rfid_result(data,50000))
	{
		terminate_rfid();
		return(1);
	}
	terminate_rfid();
	return(0);
}

public read_rfid_serial(char *data)
{
	initialize_rfid();
	write_rfid_command('I',1,0,0);
	write_cpu_register32(CPU_COM_TIMEOUT,50000);
	if(read_rfid_result(data,50000))
	{
		terminate_rfid();
		return(1);
	}
	terminate_rfid();
	return(0);
}

rfid_on()
{
	write_cpu_register(3983,65280+16);					// LATG4  TagIt ON versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3992,(256*(255-16)));					// TRISG4 TagIt ON versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3994,(256*(255-8)));					// TRISJ3  TagIt ON versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3987,255*256+8);
	if(reading_rfid==0)
	{	
		set_lcd_light_power(-1);						// Nos terminais de parede a luz nao afecta
	}
}

rfid_off()
{
	write_cpu_register(CPU_COMPORT_MASK,128);
	write_cpu_register(3983,(256*(255-16)));				// LATG4 TagIt OFF versao nova (usando o controle de alimentacao do terminal)
	write_cpu_register(3994,65280+8);				// TRISJ3 TagIt OFF versao nova (usando o controle de alimentacao do terminal)

						// 3987 TRIS PORTA B valor 8
						// 3978 valor de saida da porta B valor bit 8
						// para desligar por o tris a 0 e o valor a 0
						// para ligar por 1 no tris
	write_cpu_register(3978,256*(255-8));						
	write_cpu_register(3987,256*(255-8));

}

#ENDIF;



// ------------------------------------ Rfid125  -------------------------------------------------------------------

#IF tag_type Rfid125 ;


rfid_on()
{
	write_cpu_register(3975,65280+2);			// laser/IR power ON
	write_cpu_register(CPU_COMPORT_MASK,32);
	write_cpu_register(1,65024);			// laser/IR power ON
}

rfid_off()
{
	write_cpu_register(3975,65280-2*256);			// laser/IR power OFF
	write_cpu_register(CPU_COMPORT_MASK,0);	
	write_cpu_register(1,65024+1);			// laser/IR power ON
}


public configure_rfid125(char *data)
{
int n;
	initialize_rfid();	
	delay(50000);
/*
	cls();
	print_string(data);
	beep(500,500);
*/
	for(n=0;n<strlen(data);n++)
	{
		laser_write_byte(*(data+n));
	}
	read_rfid_result(temp_string,250000);
	terminate_rfid();
	return(0);
	
}



configure_eeprom()
{
	int start;
	
	if(start==0)
	{
		read_rfid_result(temp_string,250000);
		laser_write_byte('s');
		read_rfid_result(temp_string,250000);

		delay(20000);
		laser_write_byte('w');
		laser_write_byte('p');
		laser_write_byte('0');
		laser_write_byte('B');
		laser_write_byte('0');
		laser_write_byte('0');
		read_rfid_result(temp_string,250000);
		
		laser_write_byte('w');
		laser_write_byte('p');
		laser_write_byte('1');
		laser_write_byte('0');
		laser_write_byte('0');
		laser_write_byte('2');		
		
		read_rfid_result(temp_string,250000);

		start=1;
	}

}


public read_rfid_result(char *data,int timeout)
{
int x;
	char *data2;
	data2=data;
	*data=0;
	write_cpu_register32(CPU_COM_TIMEOUT,timeout);

	do
	{
		*data=laser_read_byte();
		if(*data==255)
		{
			return(0);	
		}
		if(*data==13)
		{
			*data=0;
			laser_read_byte();
			break;	
		}
		data++;
	}while(1);
	
	if(*data2=='N' && *(data2+1)==0)
	{
		return(0);
	}

	return(1);
}

public initialize_rfid()
{
	int n;
	status_rfid=1;
	set_baud_rate(9600);
	rfid_on();
	configure_eeprom();
}	

public terminate_rfid()
{
	status_rfid=0;
	rfid_off();
}	



public read_rfid_serial(char *data)
{
	initialize_rfid();
	delay(200000);
	laser_write_byte('s');
	if(read_rfid_result(data,1250000))
	{
		terminate_rfid();
		return(1);
	}
	beep(5,5);
	terminate_rfid();
	return(0);
}


public read_rfid_serial_always(char *data)
{
	int rfid_result;
	initialize_rfid();
	delay(50000);
	empty_com2_buffer();
	do
	{	
		laser_write_byte('s');
		if(rfid_result=read_rfid_result(data,1250000))
		{
			terminate_rfid();
			return(1);
		}
		beep(5,5);
	}
	while(inkey()!=0 && rfid_result==0 );
	
	terminate_rfid();
	return(0);
}
#ENDIF;


// ----------------------------------------------------------------------------------------------------


#IF tag_type TagIt novatronica Calypso Rfid125 ;


enable_rfid_reading()
{
	reading_rfid=1;
	initialize_rfid();
}

disable_rfid_reading()
{
	reading_rfid=0;
	terminate_rfid();
}

#IF tag_type Calypso TagIt Rfid125;
int read_any(char *temp_string)
{
	*temp_string=0;
	
	do
	{
		if(read_rfid_serial_always(temp_string))
		{		
			return(2);				
		}

		if(inkey())
		{
			sensech();
			return(0);
		}
	}
	while(1);
}
#ENDIF ;


#IF tag_type novatronica ;
int read_any(char *temp_string)
{
	int n,p,rfid_ptr;
	int key;
	int *rfid;
	char auxstring[100];
	int readrfid;
	int time,rfid_time;

	readrfid=0;
	rfid_ptr=0;
	time=get_seconds();
	initialize_rfid();
	rfid_time=15;
	*temp_string=0;
	do
	{
#IF tag_type novatronica ;
		set_rfid_baud_rate(9600);
		set_com2_baud_rate(9600);
#ENDIF ;
		do
		{
			if(!hardware_is_pricechecker)
			{
				if(inkey())
				{
					sensech();
					return(0);
				}
			}
#IF tag_type novatronica ;
			if(rfid_time)
			{	
				if(rfid_time<(get_seconds()-time))
				{
					return(2);	
				}
			}
#ENDIF ;

			write_cpu_register32(CPU_COM_TIMEOUT,10000);
			key=read_com2_byte();


		}
		while(key==-1);

										// 8 RFID, 128 RXD, 32 PSC, 
		if(!(read_cpu_register(CPU_COMPORT_MASK)&8))
		{

			while( key!='*' && key!=-1 )
			{
				key=read_com2_byte();
			}				

			if(key=='*')
			{
				p=0;
				key=read_com2_byte();
				do
				{
					temp_string[p]=key;
					p++;
					key=read_com2_byte();
				}
				while( key>='0' && key<='9' );

				temp_string[p]=0;
				if(key==13)
				{
					key=read_com2_byte();

					if(key==10)
					{
						beep(100,100);
						return(1);
					}
				}
			}
		}
		else
		{
			
#IF tag_type novatronica ;				
			if(isalnum(key))
			{

				write_cpu_register32(CPU_COM_TIMEOUT,100000);
				while(key!=-1 && key!=',')
				{
					temp_string[rfid_ptr]=key;
					if(rfid_ptr<(RfidSize-2))
					{
						rfid_ptr++;
					}
					key=read_com2_byte();
				}

				temp_string[rfid_ptr]=',';
				if(rfid_ptr<(RfidSize-1))
				{
					rfid_ptr++;
				}
				temp_string[rfid_ptr]=0;
				beep(50,50);
				if(!rfid_time || rfid_ptr==(RfidSize-1))
				{	
					return(2);
				}
			}
#ENDIF ;
		}
	}
	while(1);
}
#ENDIF ;



itoa64_(int value,char *txt,int n)
{
	int *high,*low;
	low=txt;
	high=txt+4;

ASM push_parameter 0 ;

ASM push_parameter txt_func_itoa64 ;

//ASM push_parameter 3 ;
//ASM push_parameter 4 ;

push_variable(*high);
push_variable(*low);

ASM define_char ;

pop_variable();	

}

itoa64(int value,char *txt,int n)
{
ASM push_parameter 1 ;
ASM push_parameter txt_func_itoa64 ;
ASM push_parameter 3 ;
ASM push_parameter 4 ;
ASM define_char ;
pop_variable();

	
}

#ENDIF ;


int atoi(char *txt)
{
	if(*txt!='-')
	{
		return(pic_atoi(txt));
	}
	else
	{
		return(0-pic_atoi(txt+1));
	}
}


